/* $Id: DCUPComponentManagerRMISkeleton.java,v 1.3 2004/05/20 14:23:50 bures Exp $ */
package SOFA.Connector.Boot;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import SOFA.Component.ComponentLifecycleException;
import SOFA.Component.DCUP.DCUPComponentManager;
import SOFA.Connector.ConnectorTransportException;
import SOFA.Connector.Linkable;
import SOFA.Connector.RoleBase;
import SOFA.SOFAnode.Run.Storage;

public class DCUPComponentManagerRMISkeleton extends UnicastRemoteObject implements CNDCUPComponentManagerRemoteInterface, Linkable {

  private DCUPComponentManager tgt = null;

  public DCUPComponentManagerRMISkeleton(String name) throws RemoteException {
    super();
    try {
      String rmihost = System.getProperty("sofa.rmihost", "localhost");
      String rmiport = System.getProperty("sofa.rmiport", "1099");
      SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock rg = (SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock) java.rmi.Naming.lookup("//"+rmihost+":"+rmiport+"/RgRMIDock");
    rg.rebind("/SOFA/Connectors/Boot/DCUPComponentManagerRMISkeleton/"+name, this);
//      java.rmi.Naming.rebind(name, this);
    } catch (Exception e) {
      throw new RemoteException("Can't create DCUPComponentManagerRMISkeleton", e) ;
    }
  }

  public void link(Object target) {
    tgt = (DCUPComponentManager) target;
  }

  public void createComponent(Storage stateStore) throws ComponentLifecycleException, RemoteException {
    tgt.createComponent(stateStore);
  }

  public void destroyComponent(Storage stateStore) throws ComponentLifecycleException, RemoteException {
    tgt.destroyComponent(stateStore);
  }

  public void storeComponent(Storage stateStore) throws ComponentLifecycleException, RemoteException {
    tgt.storeComponent(stateStore);
  }

  public void restoreComponent(Storage stateStore) throws ComponentLifecycleException, RemoteException {
    tgt.restoreComponent(stateStore);
  }


  public void updateComponent( byte[] newDeploymentDescriptor, Storage stateStore) throws ComponentLifecycleException, RemoteException {
    SOFA.SOFAnode.Run.Deployment.DeploymentDescriptorImpl ddr = new SOFA.SOFAnode.Run.Deployment.DeploymentDescriptorImpl();
    try {
      ddr._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(newDeploymentDescriptor));
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the \"updateComponent\".", e);
    }

    tgt.updateComponent(ddr, stateStore);
  }

  public void registerSubcomponent(java.lang.String name, byte[] target) throws SOFA.Component.NamingException, SOFA.Component.InstantiationException, RemoteException {
    SOFA.Connector.Reference ref = new SOFA.Connector.Reference();
    try {
      ref._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(target));
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the \"registerSubcomponent\".", e);
    }

    tgt.registerSubcomponent(name, ref);
  }
  
  public void unregisterSubcomponent(java.lang.String name) throws SOFA.Component.NamingException, RemoteException {
    tgt.unregisterSubcomponent(name);
  }
  
  public byte[] getProvisionReference(String name) throws SOFA.Component.NamingException, RemoteException {
    SOFA.Connector.Reference ref = tgt.getProvisionReference(name);
    
    ref = DeplDockRMISkel.removeLocal(ref);
    cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = null;
    try {
      os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      ref._write(os);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the \"getProvisionReference\".", e);
    }
    return os.toByteArray();
  }
  
  public void setRequirement(String name, byte[] ref) throws SOFA.Component.InstantiationException, SOFA.Component.NamingException, RemoteException {
    SOFA.Connector.Reference rref = new SOFA.Connector.Reference();
    try {
      rref._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(ref));
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the \"registerSubcomponent\".", e);
    }
    tgt.setRequirement(name, rref);
  }
  
  public void connectSubsumable() throws SOFA.Component.NamingException, SOFA.Component.InstantiationException, RemoteException {
    tgt.connectSubsumable();
  }

  public SOFA.SOFAnode.Run.Deployment.DeplDock getLocalDeplDock() {
    return null;
  }

  public String getFullName() {
    return tgt.getFullName();
  }

  public boolean isUpdatable() {
    return tgt.isUpdatable();
  }

  public byte[][][] getFcInterfaces() throws RemoteException {
    Object[] obs = tgt.getFcInterfaces();
    byte[][][] ret = new byte [obs.length][2][];
    for (int i=0; i<obs.length; i++) {
      SOFA.Connector.Reference ref = ((RoleBase) obs[i]).getSOFAReference();
      ref = DeplDockRMISkel.removeLocal(ref);
      cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = null;
      try {
        os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
        ref._write(os);
      } catch (java.io.IOException e) {
        throw new ConnectorTransportException("Can't serialize in the \"getFcInterfaces\".", e);
      }
      String s = Helper.getCDLNameOfObject(obs[i]);
      ret[i][0] = s==null?null:s.getBytes();
      ret[i][1] = os.toByteArray(); 
    }
    return ret;
  }
  
  public byte[][] getFcInterface(java.lang.String itfName) throws org.objectweb.fractal.api.NoSuchInterfaceException, RemoteException {
    RoleBase rb = (RoleBase) tgt.getFcInterface(itfName);
    SOFA.Connector.Reference ref = rb.getSOFAReference();
    
    byte[][] ret = new byte [2][];
    ref = DeplDockRMISkel.removeLocal(ref);
    cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = null;
    try {
      os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      ref._write(os);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the \"getFcInterface\".", e);
    }
    String s = Helper.getCDLNameOfObject(rb);
    ret[0] = s==null?null:s.getBytes();
    ret[1] = os.toByteArray();
    return ret;
  }
  
  public byte[] getFcType() throws RemoteException {
    SOFA.Connector.Reference ref = ((RoleBase) tgt.getFcType()).getSOFAReference();
    
    ref = DeplDockRMISkel.removeLocal(ref);
    cz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = null;
    try {
      os = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();
      ref._write(os);
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't serialize in the \"getFcInterface\".", e);
    }
    return os.toByteArray();
  }

  public boolean isFcSubtypeOf(byte[] t) throws RemoteException {
    SOFA.Connector.Reference rref = new SOFA.Connector.Reference();
    try {
      rref._read(new cz.cuni.sofa.lib.Impl.ByteArrayInputStream(t));
    } catch (java.io.IOException e) {
      throw new ConnectorTransportException("Can't deserialize in the \"isFcSubtype\".", e);
    }
    try {
      return tgt.isFcSubtypeOf((SOFA.Component.DCUP.DCUPComponentManager) DCUPComponentManagerConnector.createClt(rref));
    } catch (SOFA.Connector.ConnectorException e) {
      throw new ConnectorTransportException("Cannot create connector to the type.", e);
    }
  }

}
