/*
 * ConnectorInputDescriptor.java
 *
 * Created on 2. duben 2002, 20:31
 */

package SOFA.Connector.ECG;

import org.w3c.dom.Element;
import org.w3c.dom.Node;

/**
 *
 * @author  ghort
 * @version 
 */
public class ConnectorInputDescriptor {

	public String instanceName;
	
	public String unit;

	public String implementation;
	
	public SOFA.Connector.Property[] props;
	
	public SOFA.Connector.Property[] techProps; // mozna do props
	
	public UnitInterface provides[];
	public UnitInterface requires[];

	public SOFA.Connector.EEG.ElementInputDescriptor[] elements;
	
	/** Creates new ElementInputDescriptor */
	public ConnectorInputDescriptor() {
	}

	static public ConnectorInputDescriptor fromXML(Element rootElement) throws ConnectorDescriptorXMLException {
		ConnectorInputDescriptor cid=new ConnectorInputDescriptor();
		java.util.LinkedList descrProps=new java.util.LinkedList();
		java.util.LinkedList provIfaces=new java.util.LinkedList();
		java.util.LinkedList reqIfaces=new java.util.LinkedList();
		java.util.LinkedList elems=new java.util.LinkedList();

		if (!rootElement.hasAttribute("name")) {
			throw new ConnectorDescriptorXMLException("Element doesn't have 'name' attribute.");
		}
		cid.instanceName=rootElement.getAttribute("name");

		if (!rootElement.hasAttribute("unit")) {
			throw new ConnectorDescriptorXMLException("Element doesn't have 'unit' attribute.");
		}
		cid.unit=rootElement.getAttribute("unit");

		if (!rootElement.hasAttribute("impl")) {
			throw new ConnectorDescriptorXMLException("Element doesn't have 'impl' attribute.");
		}
		cid.implementation=rootElement.getAttribute("impl");
		
		if (rootElement.hasAttribute("provides")) {
			provIfaces.add(new UnitInterface(rootElement.getAttribute("provides"),cid.unit));
		}
		
		if (rootElement.hasAttribute("requires")) {
			reqIfaces.add(new UnitInterface(rootElement.getAttribute("requires"),cid.unit));
		}
		
		Node node=rootElement.getFirstChild();
		while (node!=null) {
			if (node.getNodeType()==Node.ELEMENT_NODE) {
				Element el=(Element)node;
				if (((Element)el).getNodeName().equals("property") && el.hasAttribute("name") && el.hasAttribute("value")) {
					descrProps.add(new SOFA.Connector.Property(el.getAttribute("name"),el.getAttribute("value")));
				} 
				else if (el.getNodeName().equals("otherUnit") && el.hasAttribute("name")) {
					if (el.hasAttribute("provides")) {
						provIfaces.add(new UnitInterface(el.getAttribute("provides"),el.getAttribute("name")));
					}
					if (rootElement.hasAttribute("requires")) {
						reqIfaces.add(new UnitInterface(rootElement.getAttribute("requires"),el.getAttribute("name")));
					}
				}
				else if (el.getNodeName().equals("element") && el.hasAttribute("name") && el.hasAttribute("impl")) {
					try {
						elems.add(SOFA.Connector.EEG.ElementInputDescriptor.fromXML(el));
					} catch (Exception e) {
						throw new ConnectorDescriptorXMLException("Can't parse connector element.",e);
					}
				}
			}
			node=node.getNextSibling();
		}
		
		int i;
		Object[] arr;
		
		cid.techProps=new SOFA.Connector.Property[0]; // FIXME: mela by se nacitat take z XML

		cid.props=new SOFA.Connector.Property[(arr=descrProps.toArray()).length];
		for (i=0;i<arr.length;i++) {
			cid.props[i]=(SOFA.Connector.Property)arr[i];
		}

		cid.elements=new SOFA.Connector.EEG.ElementInputDescriptor[(arr=elems.toArray()).length];
		for (i=0;i<arr.length;i++) {
			cid.elements[i]=(SOFA.Connector.EEG.ElementInputDescriptor)arr[i];
		}

		cid.provides=new UnitInterface[(arr=provIfaces.toArray()).length];
		for (i=0;i<arr.length;i++) {
			cid.provides[i]=(UnitInterface)arr[i];
		}

		cid.requires=new UnitInterface[(arr=reqIfaces.toArray()).length];
		for (i=0;i<arr.length;i++) {
			cid.requires[i]=(UnitInterface)arr[i];
		}
		
		return cid;
	}
}
