/*
 * CSProcCallImpl.java
 *
 * Created on 5. duben 2002, 13:50
 */

package SOFA.Connector.ECG.SGenerator.Connectors;

import SOFA.Connector.ConnectorException;
import SOFA.Connector.LinkException;
import SOFA.Connector.Linkable;
import SOFA.Connector.Reference;
import SOFA.Connector.RoleBase;
import SOFA.Connector.RoleBaseImpl;
import SOFA.Connector.TaggedProfile;
import SOFA.Connector.EEG.Types.CRole;
import SOFA.Connector.EEG.Types.Interceptor;
import SOFA.Connector.EEG.Types.SRole;
import SOFA.Connector.EEG.Types.Skeleton;
import SOFA.Connector.EEG.Types.Stub;

/**
 *
 * @author  ghort
 * @version 
 */
public class CSProcCallImpl extends RoleBaseImpl implements SOFA.Connector.ECG.Types.CSProcCall, SOFA.Connector.EEG.ConnectorManagerInterface {

	protected CRole cRole;
	protected Interceptor cInterceptor;
	protected Stub stub;

	protected SRole sRole;
	protected Interceptor sInterceptor;
	protected Skeleton skeleton[];
	
	/** Creates new CSProcCallImpl */
	public CSProcCallImpl() {
	}

	static public RoleBase createConnector(SOFA.Connector.ECG.DeploymentDescriptor dd, ClassLoader cl) throws ConnectorException {
//                ClassLoader cl = ClassLoader.getSystemClassLoader();
                //ClassLoader cl = getClass().getClassLoader();
		CSProcCallImpl pc=new CSProcCallImpl();
		RoleBase role=null;
		if (dd.unit.equals("Client")) {
			try {
				Linkable last;

				SOFA.Connector.EEG.ElementOutputDescriptor cRoleClass=SOFA.Connector.EEG.ElementOutputDescriptor.findFirst(dd.elements,"cRole");
//				pc.cRole=(CRole)Class.forName(cRoleClass.impl,true, new SOFA.SOFAnode.Run.SOFASystemClassLoader()).newInstance();
                                pc.cRole=(CRole)Class.forName(cRoleClass.impl, true, cl).newInstance();
				pc.cRole.setManagerTie(pc);
				last=pc.cRole;

				SOFA.Connector.EEG.ElementOutputDescriptor cInterceptorClass=SOFA.Connector.EEG.ElementOutputDescriptor.findFirst(dd.elements,"cInterceptor");
				if (cInterceptorClass!=null) {
					pc.cInterceptor=(Interceptor)Class.forName(cInterceptorClass.impl, true, cl).newInstance();
					pc.cInterceptor.setManagerTie(pc);
					last.link(pc.cInterceptor);
					last=pc.cInterceptor;
				}
				
				SOFA.Connector.EEG.ElementOutputDescriptor stubClass=SOFA.Connector.EEG.ElementOutputDescriptor.findFirst(dd.elements,"stub");
				pc.stub=(Stub)Class.forName(stubClass.impl,true, cl).newInstance();
				pc.stub.setManagerTie(pc);
				last.link(pc.stub);
				
				pc.setDeploymentDescriptor(dd);

				role=pc.cRole;
			} catch (Exception e) {
				throw new ConnectorException("Can't instantiate cRole.",e);
			}
		} else if (dd.unit.equals("Server")) {
			try {
				Object last;

				SOFA.Connector.EEG.ElementOutputDescriptor sRoleClass=SOFA.Connector.EEG.ElementOutputDescriptor.findFirst(dd.elements,"sRole");
				pc.sRole=(SRole)Class.forName(sRoleClass.impl,true, cl).newInstance();
//                                pc.sRole=(SRole)Class.forName(sRoleClass.impl).newInstance();
				pc.sRole.setManagerTie(pc);
				last=pc.sRole;
				
				SOFA.Connector.EEG.ElementOutputDescriptor sInterceptorClass=SOFA.Connector.EEG.ElementOutputDescriptor.findFirst(dd.elements,"sInterceptor");
				if (sInterceptorClass!=null) {
					pc.sInterceptor=(Interceptor)Class.forName(sInterceptorClass.impl, true, cl).newInstance();
					pc.sInterceptor.setManagerTie(pc);
					pc.sInterceptor.link(last);
					last=pc.sInterceptor;
				}

				int i, skelNum=0;
				for (i=0;i<dd.elements.length;i++) {
					if (dd.elements[i].name.equals("skeleton")) {
						skelNum++;
					}
				}

				pc.skeleton=new Skeleton[skelNum];
				java.util.LinkedList profiles=new java.util.LinkedList();

				skelNum=0;
				for (i=0;i<dd.elements.length;i++) {
					if (dd.elements[i].name.equals("skeleton")) {
						pc.skeleton[skelNum]=(Skeleton)Class.forName(dd.elements[i].impl,true, cl).newInstance();
						pc.skeleton[skelNum].setManagerTie(pc);
						pc.skeleton[skelNum].link(last);
						
						TaggedProfile[] prf=pc.skeleton[skelNum].getProfiles();
						for (int j=0;j<prf.length;j++) {
							profiles.add(prf[j]);
						}
						skelNum++;
					}
				}

				TaggedProfile[] prf=new TaggedProfile[profiles.size()];
				java.util.Iterator iter=profiles.iterator();
				for (i=0;iter.hasNext();i++) {
					prf[i]=(TaggedProfile)iter.next();
				}
				
				pc.setSOFAReference(new Reference(dd.impl,prf));
				pc.setDeploymentDescriptor(dd);
				
				role=pc.sRole;
			} catch (Exception e) {
				throw new ConnectorException("Can't instantiate sRole.",e);
			}
		} else {
			throw new ConnectorException("Unknown unit '"+dd.unit+"'.");
		}
		return role;
	}

	public void link(Object target) throws LinkException {
		Reference ref=(Reference)target;
		String[] profileNames=stub.getSupportedProfiles();
		int i, j;

		for (i=0;i<profileNames.length;i++) {
			for (j=0;j<ref.profiles.length;j++) {
				if (profileNames[i].equals(ref.profiles[j].tag)) {
					stub.link(ref.profiles[j]);
					return;
				}
			}
		}
	}

        public String getName() {
          return getConnectorName();
        }

}
