/*
 * SGenerator.java
 *
 * Created on 6. duben 2002, 9:31
 */

package SOFA.Connector.ECG.SGenerator;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import SOFA.Connector.ECG.VariableExpander;

/**
 *
 * @author  ghort
 * @version 
 */
public class SGenerator implements SOFA.Connector.ECG.ECGPluginInterface {

	protected java.util.LinkedList connectors; /* of ConnectorArchitecture */
	
	protected javax.xml.parsers.DocumentBuilderFactory documentBuilderFactory;
	protected javax.xml.parsers.DocumentBuilder documentBuilder;
	
	protected Document configDoc;
	
	protected java.util.HashMap props;

	protected SOFA.Connector.EEG.EEGenerator eeGenerator;

	/** Creates new SGenerator */
	public SGenerator(SOFA.Connector.EEG.EEGenerator eeGenerator, java.util.HashMap props) throws SOFA.Connector.ECG.ECGPluginException {
		this.props=props; 
		this.eeGenerator=eeGenerator;
		 
		try {
			documentBuilderFactory=javax.xml.parsers.DocumentBuilderFactory.newInstance();
			documentBuilder=documentBuilderFactory.newDocumentBuilder();
		
			String confFile=(String)props.get("configuration");
			if (confFile==null) {
				confFile="SGenerator/conf.xml";
			}
			confFile=SOFA.Connector.ECG.ECGenerator.getECGConfigRoot()+"/"+confFile;
			configDoc=documentBuilder.parse(new java.io.File(confFile));

			connectors=new java.util.LinkedList();
			
			Element elParent=configDoc.getDocumentElement();
			Node elPlugins, elPlugin, elUnit, elElement, elProp;
			Element elc, elu, ele, elp;
			java.util.Iterator iter;
			int i;
			
			System.out.println("    Loading connectors specification:");
			elPlugins=elParent.getFirstChild();
			while (elPlugins!=null) {
				if (elPlugins.getNodeType()==Node.ELEMENT_NODE && elPlugins.getNodeName().equals("Connectors")) {
					elPlugin=elPlugins.getFirstChild();
					while (elPlugin!=null) {
						if (elPlugin.getNodeType()==Node.ELEMENT_NODE && elPlugin.getNodeName().equals("Connector")) {
							elc=(Element)elPlugin;
	
							if (!(elc.hasAttribute("name") && elc.hasAttribute("type") && elc.hasAttribute("impl"))) {
								throw new SOFA.Connector.ECG.ECGPluginException("Missing attributes in connector declaration");
							}
							
							ConnectorArchitecture ca=new ConnectorArchitecture();
							ca.type=elc.getAttribute("type");
							ca.name=elc.getAttribute("name");
							ca.implementation=elc.getAttribute("impl");

							System.out.println("      Connector '"+ca.name+"' ("+ca.type+")");

							java.util.LinkedList units=new java.util.LinkedList();

							elUnit=elPlugin.getFirstChild();
							while (elUnit!=null) {
								if (elUnit.getNodeType()==Node.ELEMENT_NODE && elUnit.getNodeName().equals("unit")) {
									elu=(Element)elUnit;

									if (!elu.hasAttribute("name")) {
										throw new SOFA.Connector.ECG.ECGPluginException("Missing 'name' attributes in unit declaration");
									}

									ConnectorUnit cu=new ConnectorUnit();
									cu.unitName=elu.getAttribute("name");
									if (elu.hasAttribute("provides")) {
										cu.provides=elu.getAttribute("provides");
									}
									if (elu.hasAttribute("requires")) {
										cu.requires=elu.getAttribute("requires");
									}
									
									System.out.println("        Unit '"+cu.unitName+"'");

									java.util.LinkedList elements=new java.util.LinkedList();
									java.util.LinkedList pars=new java.util.LinkedList();

									elElement=elUnit.getFirstChild();
									while (elElement!=null) {
										if (elElement.getNodeType()==Node.ELEMENT_NODE) {
											ele=(Element)elElement;
											if (ele.getNodeName().equals("element")) {

												if (!(ele.hasAttribute("name") && ele.hasAttribute("type"))) {
													throw new SOFA.Connector.ECG.ECGPluginException("Missing attributes in element declaration");
												}

												ConnectorElement ce=new ConnectorElement();
												ce.instanceName=ele.getAttribute("name");
												ce.type=ele.getAttribute("type");
												ce.required=!ele.getAttribute("required").equals("no");

												System.out.println("          Element '"+ce.instanceName+"' ("+ce.type+")");

												java.util.LinkedList eProps=new java.util.LinkedList();

												elProp=elElement.getFirstChild();
												while (elProp!=null) {
													if (elProp.getNodeType()==Node.ELEMENT_NODE && elProp.getNodeName().equals("property")) {
														elp=(Element)elProp;

														if (elp.hasAttribute("name") && elp.hasAttribute("value")) {
															eProps.add(new SOFA.Connector.Property(elp.getAttribute("name"),elp.getAttribute("value")));
														}
													}
													elProp=elProp.getNextSibling();
												}

												ce.props=new SOFA.Connector.Property[eProps.size()];
												iter=eProps.iterator(); i=0;
												while (iter.hasNext()) {
													ce.props[i]=(SOFA.Connector.Property)iter.next();
													i++;
												}
												elements.add(ce);
											} else if (ele.getNodeName().equals("param") && ele.hasAttribute("name") && ele.hasAttribute("value")) {
												pars.add(new SOFA.Connector.Property(ele.getAttribute("name"),ele.getAttribute("value")));
											} 
										}

										elElement=elElement.getNextSibling();
									}

									cu.elements=new ConnectorElement[elements.size()];
									iter=elements.iterator(); 
									for (i=0;iter.hasNext();i++) {
										cu.elements[i]=(ConnectorElement)iter.next();
									}
									
									cu.params=new SOFA.Connector.Property[pars.size()];
									iter=pars.iterator();
									for (i=0;iter.hasNext();i++) {
										cu.params[i]=(SOFA.Connector.Property)iter.next();
									}

									units.add(cu);
								}
								elUnit=elUnit.getNextSibling();
							}

							ca.units=new ConnectorUnit[units.size()];
							iter=units.iterator(); i=0;
							while (iter.hasNext()) {
								ca.units[i]=(ConnectorUnit)iter.next();
								i++;
							}

							connectors.add(ca);
						}
						elPlugin=elPlugin.getNextSibling();
					}
				}
				elPlugins=elPlugins.getNextSibling();
			}
			
		} catch (Exception e) {
			throw new SOFA.Connector.ECG.ECGPluginException("Can't parse configuration",e);
		}
	}

	public SOFA.Connector.ECG.ConnectorTechnologyDescriptor[] canGenerate(SOFA.Connector.ECG.ConnectorQuery query) {
		java.util.LinkedList cTDescr=new java.util.LinkedList(); // of ConnectorTechnologDescriptor
		java.util.Iterator conIter=connectors.iterator();
		
		while (conIter.hasNext()) {
			ConnectorArchitecture ca=(ConnectorArchitecture)conIter.next();
connectorProcessing: {
				try {
					if (query.type.equals(ca.type)) {
						SOFA.Connector.ECG.ConnectorTechnologyDescriptor ctd=new SOFA.Connector.ECG.ConnectorTechnologyDescriptor();
						ctd.name=ca.name;
						ctd.implementation=getName()+":"+ca.name;
						ctd.props=new SOFA.Connector.Property[0];

						SOFA.Connector.ECG.VariableExpander expander=new SOFA.Connector.ECG.VariableExpander();
						ConnectorUnit unit=null;
						int j, k;
						
						for (j=0;j<ca.units.length;j++) {
							ConnectorUnit cu=ca.units[j];
							
							for (k=0;k<query.provides.length;k++) {
								if (query.provides[k].unit.equals(cu.unitName)) {
									if (cu.provides!=null) {
										String varName=VariableExpander.extractVariable(cu.provides);
										if (varName!=null) {
											expander.addSubst(varName,query.provides[k].iface);
										} else if (!query.provides[k].iface.equals(cu.provides)) {
											break connectorProcessing;
										}
									}
								}
							}
							
							for (k=0;k<query.requires.length;k++) {
								if (query.requires[k].unit.equals(cu.unitName)) {
									if (cu.requires!=null) {
										String varName=VariableExpander.extractVariable(cu.requires);
										if (varName!=null) {
											expander.addSubst(varName,query.requires[k].iface);
										} else if (!query.requires[k].iface.equals(cu.requires)) {
											break connectorProcessing;
										}
									}
								}
							}

							if (cu.unitName.equals(query.unit)) {
								unit=cu;
							}
						}
						if (unit==null) {
							break connectorProcessing;
						}

						for (j=0;j<query.props.length;j++) {
							try {
								expander.addSubst(query.props[j].name,query.props[j].value);
							} catch (SOFA.Connector.ECG.VariableExpanderException e) {
							}
						}
					
						java.util.LinkedList elsTD=new java.util.LinkedList(); // of SOFA.Connector.EEG.ElementsTechnologyDescriptor

						for (j=0;j<unit.elements.length;j++) {
							ConnectorElement ce=unit.elements[j];
							SOFA.Connector.EEG.ElementQuery eQuery=new SOFA.Connector.EEG.ElementQuery();
							eQuery.instanceName=ce.instanceName;
							eQuery.type=ce.type;
							eQuery.props=new SOFA.Connector.Property[ce.props.length];
							for (k=0;k<ce.props.length;k++) {
								eQuery.props[k]=new SOFA.Connector.Property(ce.props[k].name,expander.expand(ce.props[k].value));
							}

							elsTD.add(eeGenerator.canGenerate(eQuery));
						}

						ctd.elementTechnologies=new SOFA.Connector.EEG.ElementsTechnologyDescriptor[elsTD.size()];
						java.util.Iterator iter=elsTD.iterator(); j=0;
						while (iter.hasNext()) {
							ctd.elementTechnologies[j]=(SOFA.Connector.EEG.ElementsTechnologyDescriptor)iter.next();
							j++;
						}
						cTDescr.add(ctd);
					}
				} catch (SOFA.Connector.ECG.VariableExpanderException e) {
					System.out.println("Can't use connector '"+ca.name+"' ("+ca.type+"):");
					System.out.println(e.getMessage());
					System.out.println(e.getCause());
					e.printStackTrace();
				}
			}
		}

		int i;
		SOFA.Connector.ECG.ConnectorTechnologyDescriptor[] ret=new SOFA.Connector.ECG.ConnectorTechnologyDescriptor[cTDescr.size()];
		java.util.Iterator iter=cTDescr.iterator(); i=0;
		while (iter.hasNext()) {
			ret[i]=(SOFA.Connector.ECG.ConnectorTechnologyDescriptor)iter.next();
			i++;
		}

		return ret;
	}
	 
	public SOFA.Connector.ECG.ConnectorOutputDescriptor generate(SOFA.Connector.ECG.ConnectorInputDescriptor cDescr) throws SOFA.Connector.ECG.ECGPluginException {
		String impl;
		int i, j, k;

		i=cDescr.implementation.indexOf(':');
		try {
			if (i==-1 || !cDescr.implementation.substring(0,i).equals(getName())) {
				throw new SOFA.Connector.ECG.ECGPluginException("Malformed implementation specification.");
			}
			impl=cDescr.implementation.substring(i+1);
		} catch (Exception e) {
			throw new SOFA.Connector.ECG.ECGPluginException("Malformed implementation specification.");
		}
	
		java.util.Iterator conIter=connectors.iterator();
		
		while (conIter.hasNext()) {
			ConnectorArchitecture ca=(ConnectorArchitecture)conIter.next();
			if (impl.equals(ca.name)) {
				SOFA.Connector.ECG.VariableExpander expander=new SOFA.Connector.ECG.VariableExpander();
				ConnectorUnit unit=null;
						
				for (j=0;j<ca.units.length;j++) {
					ConnectorUnit cu=ca.units[j];
					for (k=0;k<cDescr.provides.length;k++) {
						if (cDescr.provides[k].unit.equals(cu.unitName)) {
							if (cu.provides!=null) {
								String varName=VariableExpander.extractVariable(cu.provides);
								if (varName!=null) {
									try {
										expander.addSubst(varName,cDescr.provides[k].iface);
									} catch (SOFA.Connector.ECG.VariableExpanderException e) {
										throw new SOFA.Connector.ECG.ECGPluginException("Can't assign interfaces to elements.",e);
									}
								} else if (!cDescr.provides[k].iface.equals(cu.provides)) {
									throw new SOFA.Connector.ECG.ECGPluginException("Connector is incompatible");
								}
							}
						}
					}
									
					for (k=0;k<cDescr.requires.length;k++) {
						if (cDescr.requires[k].unit.equals(cu.unitName)) {
							if (cu.requires!=null) {
								String varName=VariableExpander.extractVariable(cu.requires);
								if (varName!=null) {
									try {
										expander.addSubst(varName,cDescr.requires[k].iface);
									} catch (SOFA.Connector.ECG.VariableExpanderException e) {
										throw new SOFA.Connector.ECG.ECGPluginException("Can't assign interfaces to elements.",e);
									}
								} else if (!cDescr.requires[k].iface.equals(cu.requires)) {
									throw new SOFA.Connector.ECG.ECGPluginException("Connector is incompatible");
								}
							}
						}
					}

					if (cu.unitName.equals(cDescr.unit)) {
						unit=cu;
					}
				}
				if (unit==null) {
					throw new SOFA.Connector.ECG.ECGPluginException("Can't find unit '"+cDescr.unit+"' in connector architecture.");
				}

				for (j=0;j<cDescr.props.length;j++) {
					try {
						expander.addSubst(cDescr.props[j].name,cDescr.props[j].value);
					} catch (SOFA.Connector.ECG.VariableExpanderException e) {
					}
				}
						
				SOFA.Connector.EEG.ElementInputDescriptor eDes=null;
				java.util.LinkedList eODes=new java.util.LinkedList(); // of SOFA.Connector.EEG.ElementOutputDescriptor
				try {
					for (j=0;j<unit.elements.length;j++) {
						ConnectorElement ce=unit.elements[j];

						boolean elementFound=false;
						for (k=0;k<cDescr.elements.length;k++) {
							eDes=cDescr.elements[k];
							if (eDes.instanceName.equals(ce.instanceName)) {
								elementFound=true;
								java.util.LinkedList eProps=new java.util.LinkedList();
								for (i=0;i<ce.props.length;i++) {
									try {
										eProps.add(new SOFA.Connector.Property(ce.props[i].name,expander.expand(ce.props[i].value)));
									} catch (SOFA.Connector.ECG.VariableExpanderException e) {
									}
								}
                  
								try {
									eProps.add(new SOFA.Connector.Property("resolverFile",expander.expand("{resolverFile}")));
								} catch (SOFA.Connector.ECG.VariableExpanderException e) {
								}
								
								SOFA.Connector.Property[] oldEProps=eDes.props;
								eDes.props=new SOFA.Connector.Property[eProps.size()+oldEProps.length];
								for (i=0;i<oldEProps.length;i++) {
									eDes.props[i]=oldEProps[i];
								}
								java.util.Iterator iter=eProps.iterator(); 
								while (iter.hasNext()) {
									eDes.props[i]=(SOFA.Connector.Property)iter.next();
									i++;
								}
								
								eODes.add(eeGenerator.generate(eDes)); 
							}
						}

						if (!elementFound && ce.required) {
							throw new SOFA.Connector.ECG.ECGPluginException("Can't find element '"+ce.instanceName+"' in input descriptor.");
						}
					}
				} catch (SOFA.Connector.EEG.EEGeneratorException e) {
					throw new SOFA.Connector.ECG.ECGPluginException("Can't generate element '"+eDes.instanceName+"'.",e);
				}

				SOFA.Connector.ECG.ConnectorOutputDescriptor ret=new SOFA.Connector.ECG.ConnectorOutputDescriptor();
		
				ret.name=cDescr.instanceName;
				ret.unit=cDescr.unit;
				ret.impl=ca.implementation;

				ret.params=new SOFA.Connector.Property[unit.params.length+cDescr.props.length];
				try {
					for (j=0;j<unit.params.length;j++) {
						ret.params[j]=new SOFA.Connector.Property(unit.params[j].name,expander.expand(unit.params[j].value));
					}
				} catch (SOFA.Connector.ECG.VariableExpanderUnresolvedNameException e) {
					throw new SOFA.Connector.ECG.ECGPluginException("Can't expand variable '"+unit.params[j].name+"'.",e);
				}
        for (j=0;j<cDescr.props.length;j++) {
          ret.params[j+unit.params.length]=cDescr.props[j];
        }
				
				java.util.Iterator iter=eODes.iterator();
				ret.elements=new SOFA.Connector.EEG.ElementOutputDescriptor[eODes.size()];
				for (j=0;iter.hasNext();j++) {
					ret.elements[j]=(SOFA.Connector.EEG.ElementOutputDescriptor)iter.next();
				}
					
				return ret;
			}
		}
		throw new SOFA.Connector.ECG.ECGPluginException("Connector implementation '"+cDescr.implementation+"' not found.");
	}
				 
	public String getName() {
		return "SGenerator";
	}
	 
}
