package SOFA.Connector.EEG.EEM.Actions;

import SOFA.Connector.EEG.EEM.ActionException;
import SOFA.Connector.EEG.EEM.ActionInterface;

/** Cat action. Append line with types and classfiles to the specified file. It is used as the last action for each
  * generated class file of connector.
  * 
  * @author Petr Hnetynka
  */
public class Cat implements ActionInterface {
  public Cat(java.util.HashMap props) {
  }

  public String getName() {
    return "cat";
  }

  public void perform(SOFA.Connector.Property[] params, String sourceDir, String sourcePackage, String destDir, String destPackage) throws ActionException {
    String outFile = null, types = null, classFile = null;
    if ((outFile = SOFA.Connector.Property.findFirst(params,"resolverFile")) == null) {
      throw new ActionException("\"resolverFile\" param not specified");
    }
    if ((types = SOFA.Connector.Property.findFirst(params,"types")) == null) {
      throw new ActionException("\"types\" param not specified");
    }
    if ((classFile = SOFA.Connector.Property.findFirst(params,"classFile")) == null) {
      throw new ActionException("\"classFile\" param not specified");
    }
    try {
      java.io.FileWriter fw = new java.io.FileWriter(outFile, true);  // open for append
      String rrr = java.io.File.separator;
      if (java.io.File.separator.equals("\\")) {
        rrr = java.io.File.separator + java.io.File.separator;
      }
      fw.write(destDir+java.io.File.separator+classFile+" "+destPackage.replaceAll("\\.",rrr)+java.io.File.separator+classFile+" "+types+"\n");
      fw.close();
    } catch (java.io.IOException e) {
      throw new ActionException("Cannot write type info of \""+classFile+"\".", e);
    }
  }
}
