/*
 * IDLIface.java
 *
 * Created on 2. duben 2002, 23:37
 */

package SOFA.Connector.EEG.EEM.Actions;

import SOFA.Connector.EEG.EEM.ActionException;
import SOFA.Connector.EEG.EEM.ActionInterface;

/**
 *
 * @author  ghort
 * @version 
 */
public class IDLIface implements ActionInterface {

	/** Creates new IDLIface */
   public IDLIface(java.util.HashMap props) {
   }

	public String getName() {
		return "idliface";
	}
	 
	public void perform(SOFA.Connector.Property[] params, String sourceDir, String sourcePackage, String destDir, String destPackage) throws ActionException {
		String outFile, interfaceName, ifaceCDL, generator;
		if ((outFile=SOFA.Connector.Property.findFirst(params,"file"))==null) {
			throw new ActionException("file param not specified");
		}
		if ((interfaceName=SOFA.Connector.Property.findFirst(params,"interface"))==null) {
			throw new ActionException("class param not specified");
		}
		if ((generator=SOFA.Connector.Property.findFirst(params,"generator"))==null) {
			throw new ActionException("generator param not specified");
		}
		if ((ifaceCDL=SOFA.Connector.Property.findFirst(params,"ifaceCDL"))==null) {
			throw new ActionException("ifaceCDL param not specified");
		}
		 
		try {
			SOFA.Connector.EEG.CodeWriter.IDLWriter idlwriter=new SOFA.Connector.EEG.CodeWriter.IDLWriter(ifaceCDL);
			idlwriter.setOut(destDir+"/"+outFile,destPackage,interfaceName);

			SOFA.Connector.Property[] dirParams=new SOFA.Connector.Property[params.length+3];
			dirParams[0]=new SOFA.Connector.Property("outFile",destDir+"/"+outFile);
			dirParams[1]=new SOFA.Connector.Property("outInterface",interfaceName);
			dirParams[2]=new SOFA.Connector.Property("outPackage",destPackage);
			
			for (int i=0;i<params.length;i++) {
				dirParams[i+3]=params[i];
			}
			
			Class dirClass=Class.forName(sourcePackage+"."+generator);

			Class[] coParCls=new Class[2];
			coParCls[0]=Class.forName("java.lang.String");
			coParCls[1]=Class.forName("[LSOFA.Connector.Property;");
			java.lang.reflect.Constructor dirClassCo=dirClass.getConstructor(coParCls);

			Object[] coPar=new Object[2];
			coPar[0]=ifaceCDL;
			coPar[1]=dirParams;
			SOFA.Connector.EEG.CodeWriter.IDLWriterDirector director=(SOFA.Connector.EEG.CodeWriter.IDLWriterDirector)dirClassCo.newInstance(coPar);

			idlwriter.write(director);
			 
		} catch (Exception e) {
			throw new ActionException("Can't generate java source "+destDir+"/"+outFile+".",e);
		}
	}
	 
}
