/*
 * JavaCompiler.java
 *
 * Created on 2. duben 2002, 23:37
 */

package SOFA.Connector.EEG.EEM.Actions;

import SOFA.Connector.EEG.EEM.ActionException;
import SOFA.Connector.EEG.EEM.ActionInterface;

/**
 *
 * @author  ghort
 * @version 
 */
public class JavaCompiler implements ActionInterface {

	/** Creates new JavaCompiler */
   public JavaCompiler(java.util.HashMap props) {
   }

	public String getName() {
		return "javac";
	}
	 
	public void perform(SOFA.Connector.Property[] params, String sourceDir, String sourcePackage, String destDir, String destPackage) throws ActionException {
		String source;
                String iface;
		if ((source=SOFA.Connector.Property.findFirst(params,"source"))==null) {
			throw new ActionException("source param not specified");
		}
		if ((iface=SOFA.Connector.Property.findFirst(params,"iface"))==null) {
			throw new ActionException("iface param not specified");
		}
		 
		int ret;
    String classpath="";
		try {
      classpath = SOFA.Util.ConnGenPathInfo.getConnGenClassPath(iface);
			Runtime runtime=Runtime.getRuntime();
			Process process=runtime.exec("javac -classpath "+classpath+" "+destDir+"/"+source);
			ret=process.waitFor();
		} catch (Exception e) {
			throw new ActionException("Can't compile java source "+destDir+"/"+source+".",e);
		}
		if (ret!=0) {
			throw new ActionException("Compilation 'javac -classpath "+classpath+" "+destDir+"/"+source+"' returned error ("+ret+").");
		}
	}
	 
}
