/*
 * RMISkeletonGen.java
 *
 * Created on 13. duben 2002, 21:08
 */

package SOFA.Connector.EEG.EEM.Elements;

import SOFA.Connector.EEG.CodeWriter.JWriterDirectorException;
import SOFA.Connector.EEG.EEM.Actions.JIfaceCN;
import SOFA.Connector.EEG.EEM.Actions.JIfaceCNRMI;
import SOFA.Connector.EEG.EEM.Actions.JImplWriterDirectorBase;
import SOFA.SOFAnode.Made.TIR.OperationDef;

/**
 *
 * @author  ghort
 * @version 
 */
public class RMISkeletonGen extends JImplWriterDirectorBase {

	/** Creates new RMISkeletonGen */
	public RMISkeletonGen(String provIfaceCDL, SOFA.Connector.Property[] params) {
		super(provIfaceCDL,params);
	}

	public String getExtends() {
		return "java.rmi.server.UnicastRemoteObject";
	}

	public String[] getImplements() {
		return new String[] {"SOFA.Connector.EEG.Types.Skeleton"};
	}
	
	public String getClassBody() {
		return managerTieImpl() + "\n" + linkImpl() + "\n" +
			"\tprotected String rmiURL;\n\n"+
			"\tpublic RMISkeleton() throws SOFA.Connector.ConnectorException, java.rmi.RemoteException {\n"+
			"\t\tsuper();\n"+
			"\t\ttry {\n"+
			"\t\t\tString rmihost = System.getProperty(\"sofa.rmihost\", \"localhost\");\n"+
			"\t\t\tString rmiport = System.getProperty(\"sofa.rmiport\", \"1099\");\n"+
                        "\t\t\tSOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock rg = (SOFA.SOFAnode.Run.DeplDockRegistry.RgRMIDock) java.rmi.Naming.lookup(\"//\"+rmihost+\":\"+rmiport+\"/RgRMIDock\");\n"+
                        "\t\t\tString xID = new java.rmi.server.UID().toString();\n"+
                        "\t\t\trg.rebind(\"/SOFA/Connectors/EEG/EEM/Elements/RMISkeleton/\"+xID, this);\n"+
			"\t\t\trmiURL=\"rmi://\"+rmihost+\":\"+rmiport+\"/SOFA/Connectors/EEG/EEM/Elements/RMISkeleton/\"+xID;\n"+
//			"\t\t\tjava.rmi.Naming.rebind(rmiURL,this);\n"+
			"\t\t} catch (Exception e) {\n"+
			"\t\t\tthrow new SOFA.Connector.ConnectorException(\"Can't bind RMISkeleton to '\"+rmiURL+\"'.\",e);\n"+
			"\t\t}\n"+
			"\t}\n\n"+
			"\tpublic SOFA.Connector.TaggedProfile[] getProfiles() {\n"+
			"\t\treturn new SOFA.Connector.TaggedProfile[] { new SOFA.Connector.ECG.Profiles.RMIProfile(rmiURL) };\n"+
			"\t}\n\n"+
                        "\tpublic String getFcItfName() throws java.rmi.RemoteException { return this.target.getFcItfName(); }\n\n"+
                        "\tpublic byte[] getFcItfOwner() throws java.rmi.RemoteException {\n"+
                        "\t\tSOFA.Connector.Reference ref = ((SOFA.Connector.RoleBase) this.target.getFcItfOwner()).getSOFAReference();\n"+
                        "\t\tref = SOFA.Connector.Boot.DeplDockRMISkel.removeLocal(ref);\n"+
                        "\t\tcz.cuni.sofa.lib.Impl.ByteArrayOutputStream os = null;\n"+
                        "\t\ttry {\n"+
                        "\t\t\tos = new cz.cuni.sofa.lib.Impl.ByteArrayOutputStream();\n"+
                        "\t\t\tref._write(os);\n"+
                        "\t\t} catch (java.io.IOException e) {\n"+
                        "\t\t\tthrow new SOFA.Connector.ConnectorTransportException(\"Can't serialize in the \\\"getFcItfOwner\\\".\", e);\n"+
                        "\t\t}\n"+
                        "\t\treturn os.toByteArray();\n"+
                        "\t}\n\n";
	}

	public String getMethodDef(OperationDef mt) throws JWriterDirectorException {
		return JIfaceCNRMI.getMethodDef(mt);
	}

	public String getMethodBody(OperationDef method) throws JWriterDirectorException {
		return 
			"\t\t"+declareRet(method,"ret")+"\n"+
			"\t\t"+assignRet(method,"ret")+targetCall(method,JIfaceCN.targetCallParams(method))+";\n"+
			"\t\t"+returnRet(method,"ret");
	}
}
