/*
 * ElementOutputDescriptor.java
 *
 * Created on 2. duben 2002, 20:56
 */

package SOFA.Connector.EEG;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

/**
 *
 * @author  ghort
 * @version 
 */
public class ElementOutputDescriptor {

	public String name;
	public String impl;

	public SOFA.Connector.Property[] params;
	
	/** Creates new ElementOutputDescriptor */
	public ElementOutputDescriptor() {
	}

	public ElementOutputDescriptor(Element element) throws ElementDescriptorXMLException {
		fillFromXML(element);
	}

	static public ElementOutputDescriptor findFirst(ElementOutputDescriptor elems[], String nm) {
		int i;
		for (i=0;i<elems.length;i++) {
			if (elems[i].name.equals(nm)) {
				return elems[i];
			}
		}
		return null;
	}

	public Element toXML(Document parentDoc) throws ElementDescriptorXMLException {
		Element ret=parentDoc.createElement("connector_element");
		ret.setAttribute("name",name);
		ret.setAttribute("impl",impl);

		for (int i=0;i<params.length;i++) {
			Element par=parentDoc.createElement("element_param");
			par.setAttribute("name",params[i].name);
			par.setAttribute("value",params[i].value);
			ret.appendChild(par);
		}
		return ret;
	}

	public void fillFromXML(Element element) throws ElementDescriptorXMLException {
		java.util.LinkedList pars=new java.util.LinkedList();

		if (!element.hasAttribute("name")) {
			throw new ElementDescriptorXMLException("Element doesn't have 'name' attribute.");
		}
		name=element.getAttribute("name");

		if (!element.hasAttribute("impl")) {
			throw new ElementDescriptorXMLException("Element doesn't have 'impl' attribute.");
		}
		impl=element.getAttribute("impl");
		
		Node node=element.getFirstChild();
		while (node!=null) {
			if (node.getNodeType()==Node.ELEMENT_NODE) {
				Element el=(Element)node;
				if (el.getNodeName().equals("element_param") && el.hasAttribute("name") && el.hasAttribute("value")) {
					pars.add(new SOFA.Connector.Property(el.getAttribute("name"),el.getAttribute("value")));
				}
			}
			node=node.getNextSibling();
		}
		
		int i;
		java.util.Iterator iter=pars.iterator();
		params=new SOFA.Connector.Property[pars.size()];
		for (i=0;iter.hasNext();i++) {
			params[i]=(SOFA.Connector.Property)iter.next();
		}
	}
		
	
}
