/* $Id: ByteArrayOutputStream.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */

package cz.cuni.sofa.lib.Impl;
import java.io.IOException;

/** Implementation of OutputStream over byte array.
  */
public class ByteArrayOutputStream extends cz.cuni.sofa.lib.OutputStream {

  private java.io.ObjectOutputStream out;
  private java.io.ByteArrayOutputStream internal;

  public ByteArrayOutputStream() throws IOException {
    internal = new java.io.ByteArrayOutputStream ();
    out = new java.io.ObjectOutputStream(internal);
  }

  /* from java.io.OutputStream */
  public void write(int b) throws IOException {
    out.write(b);
  }

  /** Creates a newly allocated byte array.
    * @return  the current contents of this output stream, as a byte array
    */
  public byte[] toByteArray() {
    try {
      out.close();
    } catch (IOException e) {
      System.out.println("IOException");
    }
    return internal.toByteArray();
  }

  /** Converts bytes to string.
    * @return  the current contents of this output stream, as a string
    */
  public String toString() {
    try {
      out.close();
    } catch (IOException e) {
      System.out.println("IOException");
    }
    return new String( internal.toByteArray());
  }

  public void write_boolean(boolean value) throws IOException {
    out.writeBoolean(value);
  }

  public void write_char(char value) throws IOException {
    out.writeChar(value);
  }
  
  public void write_wchar(char value) throws IOException { 
    out.writeChar(value);
  }
  
  public void write_octet(byte value) throws IOException {
    out.writeByte(value);
  }
  
  public void write_short      (short          value) throws IOException {
    out.writeShort(value);
  }
  
  public void write_ushort     (short          value) throws IOException {
    out.writeShort(value);
  }
  
  public void write_long       (int            value) throws IOException {
    out.writeInt(value);
  }
  
  public void write_ulong      (int            value) throws IOException {
    out.writeInt(value);
  }
  
  public void write_longlong   (long           value) throws IOException {
    out.writeLong(value);
  }
  
  public void write_ulonglong  (long           value) throws IOException {
    out.writeLong(value);
  }
  
  public void write_float      (float          value) throws IOException {
    out.writeFloat(value);
  }
  
  public void write_double     (double         value) throws IOException {
    out.writeDouble(value);
  }
  
  public void write_string     (String         value) throws IOException {
    out.writeUTF(value);
  }
  
  public void write_wstring    (String         value) throws IOException {
    out.writeUTF(value);
  }


  public void write_boolean_array(boolean[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeBoolean(value[i]);
    }
  }
  
  public void write_char_array(char[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeChar(value[i]);
    }
  }
  
  public void write_wchar_array(char[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeChar(value[i]);
    }
  }
  
  public void write_octet_array(byte[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeByte(value[i]);
    }
  }
  
  public void write_short_array(short[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeShort(value[i]);
    }
  }
  
  public void write_ushort_array(short[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeShort(value[i]);
    }
  }
  
  public void write_long_array(int[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeInt(value[i]);
    }
  }
  
  public void write_ulong_array(int[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeInt(value[i]);
    }
  }
  
  public void write_longlong_array(long[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeLong(value[i]);
    }
  }
  
  public void write_ulonglong_array(long[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeLong(value[i]);
    }
  }
  
  public void write_float_array(float[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeFloat(value[i]);
    }
  }
  
  public void write_double_array(double[] value, int offset, int length) throws IOException {
    for (int i=0; i<length; i++) {
      out.writeDouble(value[i]);
    }
  }


  public void write_Object(cz.cuni.sofa.lib.Object value) throws IOException {
    out.writeObject(value);
  }

    
  
}
