/*
 * InputTriggerDesc.java
 *
 * Created on 18. kvten 2004, 14:24
 */

package SOFA.SOFAnet.Admin.RMI;

import SOFA.SOFAnet.Repository.InputTrigger;
import java.io.Serializable;

/**
 *
 * @author  Ladislav Sobr
 */
public class InputTriggerDesc implements Comparable, Serializable
{
  public String name;
  public String description;
  
  /** Creates a new instance of InputTriggerDesc */
  public InputTriggerDesc(InputTrigger inputTrigger)
  {
    this.name = inputTrigger.getName();
    this.description = inputTrigger.getDescription();
  }
    
  InputTriggerDesc(String name, String description)
  {
    this.name = name;
    this.description = description;
  }

  public boolean equals(Object o)
  {
    if (this == o) return true;
    if (o instanceof InputTriggerDesc)
    {
      InputTriggerDesc inputTriggerDesc = (InputTriggerDesc)o;
      return toString().compareTo(inputTriggerDesc.toString()) == 0;
    }
    else return false;
  }

  public int compareTo(Object o)
  {
    InputTriggerDesc inputTriggerDesc = (InputTriggerDesc)o;
    return toString().compareTo(inputTriggerDesc.toString());
  }

  public String toString()
  {
    if (description.length() == 0) return name;
    else return name + " (" + description + ")";
  }
}
