/*
 * BundleOffersPanel.java
 *
 * Created on 10. kvten 2004, 17:18
 */

package SOFA.SOFAnet.Browser;

import javax.swing.*;
import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.BundleOffer;
import java.rmi.RemoteException;
import java.util.Arrays;

/**
 *
 * @author  Ladislav Sobr
 */
public class BundleOffersPanel extends javax.swing.JPanel
{
  private RMIAdminInterface admin;
  private DefaultListModel content;
  
  /** Creates new form BundleOffersPanel */
  public BundleOffersPanel(RMIAdminInterface admin)
  {
    this.admin = admin;
    content = new DefaultListModel();
    initComponents();
  }

  private void reload()
  {
    content.clear();
    
    String[] bundleOffers = null;
    try
    {
      bundleOffers = admin.bundleOffersList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    Arrays.sort(bundleOffers);
    
    content.ensureCapacity(bundleOffers.length);
    for (int i = 0; i < bundleOffers.length; i++) content.addElement(bundleOffers[i]);
  }
  
  private String getSelectedBundleOfferName()
  {
    String bundleName = "";

    int index = contentList.getSelectedIndex();
    if (index != -1) bundleName = (String)content.getElementAt(index);
    return bundleName;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel2 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    showButton = new javax.swing.JButton();
    deleteButton = new javax.swing.JButton();
    testPushBundleOfferButton = new javax.swing.JButton();
    pushBundleOfferButton = new javax.swing.JButton();
    jPanel1 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    refreshButton = new javax.swing.JButton();
    createBundleOfferlButton = new javax.swing.JButton();
    jScrollPane1 = new javax.swing.JScrollPane();
    contentList = new javax.swing.JList();

    setLayout(new java.awt.BorderLayout());

    addComponentListener(new java.awt.event.ComponentAdapter()
    {
      public void componentShown(java.awt.event.ComponentEvent evt)
      {
        formComponentShown(evt);
      }
    });

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel2.setPreferredSize(new java.awt.Dimension(200, 204));
    jPanel4.setLayout(new java.awt.GridLayout(4, 0));

    jPanel4.setBorder(new javax.swing.border.TitledBorder("Bundle Offer Specific"));
    showButton.setText("Show Bundle Offer");
    showButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        showButtonActionPerformed(evt);
      }
    });

    jPanel4.add(showButton);

    deleteButton.setText("Delete Bundle Offer");
    deleteButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteButtonActionPerformed(evt);
      }
    });

    jPanel4.add(deleteButton);

    testPushBundleOfferButton.setText("Test Push Bundle Offer");
    testPushBundleOfferButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        testPushBundleOfferButtonActionPerformed(evt);
      }
    });

    jPanel4.add(testPushBundleOfferButton);

    pushBundleOfferButton.setText("Push Bundle Offer");
    pushBundleOfferButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        pushBundleOfferButtonActionPerformed(evt);
      }
    });

    jPanel4.add(pushBundleOfferButton);

    jPanel2.add(jPanel4, java.awt.BorderLayout.NORTH);

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.TitledBorder("General"));
    jPanel3.setLayout(new java.awt.GridLayout(2, 0));

    refreshButton.setText("Refresh");
    refreshButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        refreshButtonActionPerformed(evt);
      }
    });

    jPanel3.add(refreshButton);

    createBundleOfferlButton.setText("Create Bundle Offer");
    createBundleOfferlButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createBundleOfferlButtonActionPerformed(evt);
      }
    });

    jPanel3.add(createBundleOfferlButton);

    jPanel1.add(jPanel3, java.awt.BorderLayout.NORTH);

    jPanel2.add(jPanel1, java.awt.BorderLayout.CENTER);

    add(jPanel2, java.awt.BorderLayout.EAST);

    contentList.setModel(content);
    contentList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    contentList.setVisibleRowCount(-1);
    contentList.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseClicked(java.awt.event.MouseEvent evt)
      {
        contentListMouseClicked(evt);
      }
    });

    jScrollPane1.setViewportView(contentList);

    add(jScrollPane1, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents

  private void contentListMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_contentListMouseClicked
  {//GEN-HEADEREND:event_contentListMouseClicked
    if (evt.getClickCount() == 2)
    {
      showButton.doClick(); //emulate button click
    }
  }//GEN-LAST:event_contentListMouseClicked

  private void formComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_formComponentShown
  {//GEN-HEADEREND:event_formComponentShown
    reload();
  }//GEN-LAST:event_formComponentShown

  private void pushBundleOfferButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_pushBundleOfferButtonActionPerformed
  {//GEN-HEADEREND:event_pushBundleOfferButtonActionPerformed
    PushBundleOfferDialog.showDialog(this, admin, getSelectedBundleOfferName());
  }//GEN-LAST:event_pushBundleOfferButtonActionPerformed

  private void testPushBundleOfferButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_testPushBundleOfferButtonActionPerformed
  {//GEN-HEADEREND:event_testPushBundleOfferButtonActionPerformed
    TestPushBundleOfferDialog.showDialog(this, admin, getSelectedBundleOfferName());
  }//GEN-LAST:event_testPushBundleOfferButtonActionPerformed

  private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteButtonActionPerformed
  {//GEN-HEADEREND:event_deleteButtonActionPerformed
    String bundleOfferName = getSelectedBundleOfferName();
    
    if (bundleOfferName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "No Bundle Offer selected", "Warning", JOptionPane.WARNING_MESSAGE);
      return;
    }
    else
    {
      if (JOptionPane.showConfirmDialog(this, "Do you really want to delete Bundle Offer '" + bundleOfferName + "'?") != JOptionPane.YES_OPTION) return;
    }
    
    try
    {
      admin.deleteBundleOffer(bundleOfferName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    reload();
  }//GEN-LAST:event_deleteButtonActionPerformed

  private void showButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_showButtonActionPerformed
  {//GEN-HEADEREND:event_showButtonActionPerformed
    String bundleOfferName = getSelectedBundleOfferName();
    
    if (bundleOfferName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "No Bundle Offer selected", "Warning", JOptionPane.WARNING_MESSAGE);
      return;
    }
    
    BundleOffer bundleOffer = null;
    try
    {
      bundleOffer = admin.getBundleOffer(bundleOfferName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    if (bundleOffer == null)
    {
      JOptionPane.showMessageDialog(this, "Selected Bundle Offer doesn't exist on the node anymore", "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    BundleOfferDialog.showDialog(this, bundleOffer);
  }//GEN-LAST:event_showButtonActionPerformed

  private void createBundleOfferlButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createBundleOfferlButtonActionPerformed
  {//GEN-HEADEREND:event_createBundleOfferlButtonActionPerformed
    if (CreateBundleOfferDialog.showDialog(this, admin, "")) reload();
  }//GEN-LAST:event_createBundleOfferlButtonActionPerformed

  private void refreshButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_refreshButtonActionPerformed
  {//GEN-HEADEREND:event_refreshButtonActionPerformed
    reload();
  }//GEN-LAST:event_refreshButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JList contentList;
  private javax.swing.JButton createBundleOfferlButton;
  private javax.swing.JButton deleteButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JButton pushBundleOfferButton;
  private javax.swing.JButton refreshButton;
  private javax.swing.JButton showButton;
  private javax.swing.JButton testPushBundleOfferButton;
  // End of variables declaration//GEN-END:variables
  
}
