/*
 * ContractsPanel.java
 *
 * Created on 17. kvten 2004, 20:37
 */

package SOFA.SOFAnet.Browser;

import javax.swing.*;
import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.Contract;
import java.rmi.RemoteException;
import java.util.Arrays;

/**
 *
 * @author  Ladislav Sobr
 */
public class ContractsPanel extends javax.swing.JPanel
{
  private RMIAdminInterface admin;
  private DefaultListModel content;
  
  
  /** Creates new form ContractsPanel */
  public ContractsPanel(RMIAdminInterface admin)
  {
    this.admin = admin;
    content = new DefaultListModel();
    initComponents();
  }
  
  private void reload()
  {
    content.clear();
    
    ContractDesc[] contractDescs = null;
    try
    {
      contractDescs = admin.contractDescsList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    Arrays.sort(contractDescs);
    
    content.ensureCapacity(contractDescs.length);
    for (int i = 0; i < contractDescs.length; i++) content.addElement(contractDescs[i]);
  }
  
  private String getSelectedContractName()
  {
    String contractName = "";

    int index = contentList.getSelectedIndex();
    if (index != -1) contractName = ((ContractDesc)content.getElementAt(index)).name;
    return contractName;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel2 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    editButton = new javax.swing.JButton();
    addButton = new javax.swing.JButton();
    deleteButton = new javax.swing.JButton();
    generateTriggersButton = new javax.swing.JButton();
    deleteTriggersButton = new javax.swing.JButton();
    jPanel1 = new javax.swing.JPanel();
    jPanel3 = new javax.swing.JPanel();
    refreshButton = new javax.swing.JButton();
    jScrollPane1 = new javax.swing.JScrollPane();
    contentList = new javax.swing.JList();

    setLayout(new java.awt.BorderLayout());

    addComponentListener(new java.awt.event.ComponentAdapter()
    {
      public void componentShown(java.awt.event.ComponentEvent evt)
      {
        formComponentShown(evt);
      }
    });

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel2.setPreferredSize(new java.awt.Dimension(200, 204));
    jPanel4.setLayout(new java.awt.GridLayout(5, 0));

    jPanel4.setBorder(new javax.swing.border.TitledBorder("Contract Specific"));
    editButton.setText("Edit Contract");
    editButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        editButtonActionPerformed(evt);
      }
    });

    jPanel4.add(editButton);

    addButton.setText("Add New Contract");
    addButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        addButtonActionPerformed(evt);
      }
    });

    jPanel4.add(addButton);

    deleteButton.setText("Delete Contract");
    deleteButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteButtonActionPerformed(evt);
      }
    });

    jPanel4.add(deleteButton);

    generateTriggersButton.setText("Generate Triggers");
    generateTriggersButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        generateTriggersButtonActionPerformed(evt);
      }
    });

    jPanel4.add(generateTriggersButton);

    deleteTriggersButton.setText("Delete Triggers");
    deleteTriggersButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        deleteTriggersButtonActionPerformed(evt);
      }
    });

    jPanel4.add(deleteTriggersButton);

    jPanel2.add(jPanel4, java.awt.BorderLayout.NORTH);

    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.TitledBorder("General"));
    jPanel3.setLayout(new java.awt.GridLayout(1, 0));

    refreshButton.setText("Refresh");
    refreshButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        refreshButtonActionPerformed(evt);
      }
    });

    jPanel3.add(refreshButton);

    jPanel1.add(jPanel3, java.awt.BorderLayout.NORTH);

    jPanel2.add(jPanel1, java.awt.BorderLayout.CENTER);

    add(jPanel2, java.awt.BorderLayout.EAST);

    contentList.setModel(content);
    contentList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    contentList.setVisibleRowCount(-1);
    contentList.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseClicked(java.awt.event.MouseEvent evt)
      {
        contentListMouseClicked(evt);
      }
    });

    jScrollPane1.setViewportView(contentList);

    add(jScrollPane1, java.awt.BorderLayout.CENTER);

  }//GEN-END:initComponents

  private void deleteTriggersButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteTriggersButtonActionPerformed
  {//GEN-HEADEREND:event_deleteTriggersButtonActionPerformed
    DeleteTriggersOfContractDialog.showDialog(this, admin, getSelectedContractName());
  }//GEN-LAST:event_deleteTriggersButtonActionPerformed

  private void generateTriggersButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_generateTriggersButtonActionPerformed
  {//GEN-HEADEREND:event_generateTriggersButtonActionPerformed
    GenerateTriggersOfContractDialog.showDialog(this, admin, getSelectedContractName());
  }//GEN-LAST:event_generateTriggersButtonActionPerformed

  private void refreshButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_refreshButtonActionPerformed
  {//GEN-HEADEREND:event_refreshButtonActionPerformed
    reload();
  }//GEN-LAST:event_refreshButtonActionPerformed

  private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_deleteButtonActionPerformed
  {//GEN-HEADEREND:event_deleteButtonActionPerformed
    String contractName = getSelectedContractName();
    
    if (contractName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "No Contract selected", "Warning", JOptionPane.WARNING_MESSAGE);
      return;
    }
    else
    {
      if (JOptionPane.showConfirmDialog(this, "Do you really want to delete Contract '" + contractName + "'?") != JOptionPane.YES_OPTION) return;
    }
    
    try
    {
      admin.updateContract(contractName, null);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    reload();
  }//GEN-LAST:event_deleteButtonActionPerformed

  private void addButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_addButtonActionPerformed
  {//GEN-HEADEREND:event_addButtonActionPerformed
    String contractName = JOptionPane.showInputDialog(this, "ID of New Contract:", "New Contract", JOptionPane.INFORMATION_MESSAGE);
    if (contractName != null)
    {
      Contract contract = new Contract();
      
      try
      {
        admin.updateContract(contractName, contract);
      }
      catch (RemoteException e)
      {
        JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      catch (RMIAdminException e)
      {
        JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      
      reload();
    }
  }//GEN-LAST:event_addButtonActionPerformed

  private void editButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_editButtonActionPerformed
  {//GEN-HEADEREND:event_editButtonActionPerformed
    String contractName = getSelectedContractName();
    
    if (contractName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "No Contract selected", "Warning", JOptionPane.WARNING_MESSAGE);
      return;
    }
    
    Contract contract = null;
    try
    {
      contract = admin.getContract(contractName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    if (contract == null)
    {
      JOptionPane.showMessageDialog(this, "Selected Contract doesn't exist on the node anymore", "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    if (ContractEditDialog.showDialog(this, contract, "Contract Editor"))
    {
      try
      {
        admin.updateContract(contractName, contract);
      }
      catch (RemoteException e)
      {
        JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      catch (RMIAdminException e)
      {
        JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
      
      reload();
    }    
  }//GEN-LAST:event_editButtonActionPerformed

  private void contentListMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_contentListMouseClicked
  {//GEN-HEADEREND:event_contentListMouseClicked
    if (evt.getClickCount() == 2)
    {
      editButton.doClick(); //emulate button click
    }
  }//GEN-LAST:event_contentListMouseClicked

  private void formComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_formComponentShown
  {//GEN-HEADEREND:event_formComponentShown
    reload();
  }//GEN-LAST:event_formComponentShown
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton addButton;
  private javax.swing.JList contentList;
  private javax.swing.JButton deleteButton;
  private javax.swing.JButton deleteTriggersButton;
  private javax.swing.JButton editButton;
  private javax.swing.JButton generateTriggersButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JButton refreshButton;
  // End of variables declaration//GEN-END:variables
  
}
