/*
 * InstallBundleDialog.java
 *
 * Created on 10. kvten 2004, 22:42
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.BundleInfo;
import SOFA.SOFAnode.TR.ComponentInfo;
import SOFA.SOFAnode.TR.Impl.ComponentInfoImpl;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class CreateComponentBundleDialog extends javax.swing.JDialog
{
  private RMIAdminInterface admin;
  private boolean isOK;

  public static boolean showDialog(Component frameComp, RMIAdminInterface admin, String defaultComponentName)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    CreateComponentBundleDialog dialog = new CreateComponentBundleDialog(frame, true, admin, defaultComponentName);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form CreateComponentBundleDialog */
  public CreateComponentBundleDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin, String defaultComponentName)
  {
    super(parent, modal);
    this.admin = admin;
    isOK = false;
    initComponents();
    
    componentNameTextField.setText(defaultComponentName);
  }
  
  public boolean isOK()
  {
    return isOK;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel4 = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    componentNameLabel = new javax.swing.JLabel();
    componentNameTextField = new javax.swing.JTextField();
    completeComponentCheckBox = new javax.swing.JCheckBox();
    jPanel2 = new javax.swing.JPanel();
    chooseComponentButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    createComponentBundleButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Create Component Bundle");
    jPanel4.setLayout(new java.awt.BorderLayout());

    jPanel4.setMinimumSize(new java.awt.Dimension(400, 93));
    jPanel4.setPreferredSize(new java.awt.Dimension(400, 150));
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 10, 1, 10)));
    jPanel1.setMinimumSize(new java.awt.Dimension(26, 23));
    jPanel1.setPreferredSize(new java.awt.Dimension(26, 23));
    jPanel5.setLayout(new java.awt.GridLayout(3, 0));

    componentNameLabel.setText("Component Name:");
    jPanel5.add(componentNameLabel);

    componentNameTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    componentNameTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(componentNameTextField);

    completeComponentCheckBox.setText("Complete Component (including subcomponents)");
    jPanel5.add(completeComponentCheckBox);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    jPanel4.add(jPanel1, java.awt.BorderLayout.CENTER);

    chooseComponentButton.setText("Choose Component from TR");
    chooseComponentButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        chooseComponentButtonActionPerformed(evt);
      }
    });

    jPanel2.add(chooseComponentButton);

    jPanel4.add(jPanel2, java.awt.BorderLayout.NORTH);

    createComponentBundleButton.setText("Create Component Bundle");
    createComponentBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        createComponentBundleButtonActionPerformed(evt);
      }
    });

    jPanel3.add(createComponentBundleButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    jPanel4.add(jPanel3, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void chooseComponentButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_chooseComponentButtonActionPerformed
  {//GEN-HEADEREND:event_chooseComponentButtonActionPerformed
    ComponentInfo[] componentInfos = null;
    try
    {
      componentInfos = admin.componentsInTRList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    String[] compNames = new String[componentInfos.length];
    int i;
    for (i = 0; i < componentInfos.length; i++) compNames[i] = componentInfos[i].getName() + "[" + componentInfos[i].getImplementationVersion() + "]";
    
    Arrays.sort(compNames);
    
    String result = ListDialog.showDialog(this, this, "Components in TR:", "Choose Components from TR to create Component Bundle", compNames, null, null, false, true);
    if (result.length() != 0) componentNameTextField.setText(result);
    
  }//GEN-LAST:event_chooseComponentButtonActionPerformed

  private void createComponentBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_createComponentBundleButtonActionPerformed
  {//GEN-HEADEREND:event_createComponentBundleButtonActionPerformed
    String componentName = componentNameTextField.getText();
    boolean completeComponent = completeComponentCheckBox.isSelected();

    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromBundleName(componentName);
    }
    catch (BundleInfo.InvalidBundleNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    if (!bundleInfo.isComponent() || bundleInfo.isCompleteComponent())
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\nName of Component expected", "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
 
    ComponentInfo componentInfo = new ComponentInfoImpl(bundleInfo.getShortName(), bundleInfo.getVersion());
    String bundleName = null;
    try
    {
      bundleName = admin.createComponentBundle(componentInfo, completeComponent);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    
    JOptionPane.showMessageDialog(this, "Component Bundle '" + bundleName + "' successfully created");
    
    isOK = true;
    dispose();
  }//GEN-LAST:event_createComponentBundleButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton cancelButton;
  private javax.swing.JButton chooseComponentButton;
  private javax.swing.JCheckBox completeComponentCheckBox;
  private javax.swing.JLabel componentNameLabel;
  private javax.swing.JTextField componentNameTextField;
  private javax.swing.JButton createComponentBundleButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  // End of variables declaration//GEN-END:variables
  
}
