/*
 * DeleteComponentsDialog.java
 *
 * Created on 17. kvten 2004, 19:21
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnode.TR.ComponentInfo;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class DeleteComponentsDialog extends javax.swing.JDialog
{
  private RMIAdminInterface admin;
  private DefaultListModel content;
  private ComponentInfo[] components;
  private boolean isOK;
  
  public static boolean showDialog(Component frameComp, RMIAdminInterface admin, ComponentInfo[] components)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    DeleteComponentsDialog dialog = new DeleteComponentsDialog(frame, true, admin, components);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form DeleteComponentsDialog */
  public DeleteComponentsDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin, ComponentInfo[] components)
  {
    super(parent, modal);
    this.admin = admin;
    this.components = components;
    isOK = false;
    content = new DefaultListModel();
    initComponents();
    
    for (int i = 0; i < components.length; i++) content.addElement(components[i].getName() + "[" + components[i].getImplementationVersion() + "]");
  }

  public boolean isOK()
  {
    return isOK;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel1 = new javax.swing.JPanel();
    jLabel1 = new javax.swing.JLabel();
    jPanel2 = new javax.swing.JPanel();
    jScrollPane1 = new javax.swing.JScrollPane();
    contentList = new javax.swing.JList();
    jPanel4 = new javax.swing.JPanel();
    subcomponentsCheckBox = new javax.swing.JCheckBox();
    interfacesCheckBox = new javax.swing.JCheckBox();
    jPanel3 = new javax.swing.JPanel();
    yesButton = new javax.swing.JButton();
    noButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Delete Components from TR");
    jLabel1.setText("Do you really want to delete these components from TR?");
    jPanel1.add(jLabel1);

    getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);

    jPanel2.setLayout(new java.awt.BorderLayout());

    contentList.setModel(content);
    contentList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    jScrollPane1.setViewportView(contentList);

    jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);

    jPanel4.setLayout(new java.awt.GridLayout(2, 0));

    subcomponentsCheckBox.setText("Including Subcomponents");
    jPanel4.add(subcomponentsCheckBox);

    interfacesCheckBox.setText("Including Interfaces");
    jPanel4.add(interfacesCheckBox);

    jPanel2.add(jPanel4, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

    yesButton.setText("Yes");
    yesButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        yesButtonActionPerformed(evt);
      }
    });

    jPanel3.add(yesButton);

    noButton.setText("No");
    noButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        noButtonActionPerformed(evt);
      }
    });

    jPanel3.add(noButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    getContentPane().add(jPanel3, java.awt.BorderLayout.SOUTH);

    pack();
  }//GEN-END:initComponents

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed

  private void noButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_noButtonActionPerformed
  {//GEN-HEADEREND:event_noButtonActionPerformed
    dispose();
  }//GEN-LAST:event_noButtonActionPerformed

  private void yesButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_yesButtonActionPerformed
  {//GEN-HEADEREND:event_yesButtonActionPerformed
    boolean interfaces = interfacesCheckBox.isSelected();
    boolean subcomponents = subcomponentsCheckBox.isSelected();
    
    try
    {
      admin.deleteComponentsFromTR(components, interfaces, subcomponents);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    
    isOK = true;
    dispose();
  }//GEN-LAST:event_yesButtonActionPerformed
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton cancelButton;
  private javax.swing.JList contentList;
  private javax.swing.JCheckBox interfacesCheckBox;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JButton noButton;
  private javax.swing.JCheckBox subcomponentsCheckBox;
  private javax.swing.JButton yesButton;
  // End of variables declaration//GEN-END:variables
  
}
