/*
 * NewNodeNameLicDialog.java
 *
 * Created on 19. kvten 2004, 11:26
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Repository.NodeNameLicList;
import SOFA.SOFAnet.Repository.Licence;
import javax.swing.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class NewNodeNameLicDialog extends javax.swing.JDialog
{
  private NodeNameLicList.NodeLicPair nodeLicPair;

  public static NodeNameLicList.NodeLicPair showDialog(Component frameComp)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    NewNodeNameLicDialog dialog = new NewNodeNameLicDialog(frame, true);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.getNodeLicPair();
  }
  
  /** Creates new form NewNodeNameLicDialog */
  public NewNodeNameLicDialog(java.awt.Frame parent, boolean modal)
  {
    super(parent, modal);
    nodeLicPair = null;
    initComponents();
  }
  
  NodeNameLicList.NodeLicPair getNodeLicPair()
  {
    return nodeLicPair;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel1 = new javax.swing.JPanel();
    nameLabel = new javax.swing.JLabel();
    nameTextField = new javax.swing.JTextField();
    numberOfLicencesPanel = new javax.swing.JPanel();
    numberOfLicencesCheckBox = new javax.swing.JCheckBox();
    numberOfLicencesTextField = new javax.swing.JTextField();
    numberOfLicencesLabel = new javax.swing.JLabel();
    jPanel2 = new javax.swing.JPanel();
    OKButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("New Node Name (with Licence)");
    jPanel1.setLayout(new java.awt.GridLayout(3, 0));

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(5, 5, 5, 5)));
    nameLabel.setText("Name of Node:");
    jPanel1.add(nameLabel);

    jPanel1.add(nameTextField);

    numberOfLicencesPanel.setLayout(new javax.swing.BoxLayout(numberOfLicencesPanel, javax.swing.BoxLayout.X_AXIS));

    numberOfLicencesCheckBox.setText("Number of Licences");
    numberOfLicencesCheckBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        numberOfLicencesCheckBoxActionPerformed(evt);
      }
    });

    numberOfLicencesPanel.add(numberOfLicencesCheckBox);

    numberOfLicencesTextField.setEnabled(false);
    numberOfLicencesPanel.add(numberOfLicencesTextField);

    numberOfLicencesLabel.setText("(use '*' or 'all' for all licences)");
    numberOfLicencesLabel.setEnabled(false);
    numberOfLicencesPanel.add(numberOfLicencesLabel);

    jPanel1.add(numberOfLicencesPanel);

    getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);

    jPanel2.setPreferredSize(new java.awt.Dimension(350, 35));
    OKButton.setText("OK");
    OKButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        OKButtonActionPerformed(evt);
      }
    });

    jPanel2.add(OKButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel2.add(cancelButton);

    getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

    pack();
  }//GEN-END:initComponents

  private void OKButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_OKButtonActionPerformed
  {//GEN-HEADEREND:event_OKButtonActionPerformed
    boolean numberOfLicencesSelected = numberOfLicencesCheckBox.isSelected();
    String numberOfLicencesText = numberOfLicencesTextField.getText().trim().toLowerCase();
    String nodeName = nameTextField.getText().trim();
    
    if (nodeName.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "Empty Node Name", "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    int numberOfLicences = Licence.ONE_IMPLICIT_LICENCE;
    if (numberOfLicencesSelected && numberOfLicencesText.length() != 0)
    {
      if (numberOfLicencesText.compareTo("*") == 0 || numberOfLicencesText.compareTo("all") == 0) numberOfLicences = Licence.ALL_LICENCES;
      else
      {
        try
        {
          numberOfLicences = Integer.parseInt(numberOfLicencesText);
          if (numberOfLicences < 0) throw new NumberFormatException("Negative 'Number of Licences' is not allowed");
        }
        catch (NumberFormatException e)
        {
          JOptionPane.showMessageDialog(this, "Error occured while parsing 'Number of Licences':\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
          return;
        }
      }
    }
    
    nodeLicPair = new NodeNameLicList.NodeLicPair(nodeName, numberOfLicences);
    dispose();
  }//GEN-LAST:event_OKButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed

  private void numberOfLicencesCheckBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_numberOfLicencesCheckBoxActionPerformed
  {//GEN-HEADEREND:event_numberOfLicencesCheckBoxActionPerformed
    numberOfLicencesTextField.setEnabled(numberOfLicencesCheckBox.isSelected());
    numberOfLicencesLabel.setEnabled(numberOfLicencesCheckBox.isSelected());    
  }//GEN-LAST:event_numberOfLicencesCheckBoxActionPerformed
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton OKButton;
  private javax.swing.JButton cancelButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JLabel nameLabel;
  private javax.swing.JTextField nameTextField;
  private javax.swing.JCheckBox numberOfLicencesCheckBox;
  private javax.swing.JLabel numberOfLicencesLabel;
  private javax.swing.JPanel numberOfLicencesPanel;
  private javax.swing.JTextField numberOfLicencesTextField;
  // End of variables declaration//GEN-END:variables
  
}
