/*
 * InstallBundleDialog.java
 *
 * Created on 10. kvten 2004, 22:42
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Repository.BundleInfo;
import SOFA.SOFAnet.Repository.NodeInfo;
import SOFA.SOFAnet.Repository.Licence;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class PushBundleDialog extends javax.swing.JDialog
{
  private RMIAdminInterface admin;
  private boolean isOK;
  
  public static boolean showDialog(Component frameComp, RMIAdminInterface admin, String defaultBundleName)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    PushBundleDialog dialog = new PushBundleDialog(frame, true, admin, defaultBundleName);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
    return dialog.isOK();
  }
  
  /** Creates new form PushBundleDialog */
  public PushBundleDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin, String defaultBundleName)
  {
    super(parent, modal);
    this.admin = admin;
    isOK = false;
    initComponents();
    
    bundleNameTextField.setText(defaultBundleName);
  }
  
  public boolean isOK()
  {
    return isOK;
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    jPanel4 = new javax.swing.JPanel();
    jPanel1 = new javax.swing.JPanel();
    jPanel5 = new javax.swing.JPanel();
    bundleNameLabel = new javax.swing.JLabel();
    bundleNameTextField = new javax.swing.JTextField();
    nodeNameLabel = new javax.swing.JLabel();
    nodeNameTextField = new javax.swing.JTextField();
    numberOfLicencesLabel = new javax.swing.JLabel();
    numberOfLicencesTextField = new javax.swing.JTextField();
    warnLabel = new javax.swing.JLabel();
    jPanel2 = new javax.swing.JPanel();
    chooseBinaryBundleButton = new javax.swing.JButton();
    showLicenceButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    pushButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Push Bundle");
    jPanel4.setLayout(new java.awt.BorderLayout());

    jPanel4.setMinimumSize(new java.awt.Dimension(400, 93));
    jPanel4.setPreferredSize(new java.awt.Dimension(400, 230));
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 10, 1, 10)));
    jPanel1.setMinimumSize(new java.awt.Dimension(26, 23));
    jPanel1.setPreferredSize(new java.awt.Dimension(26, 23));
    jPanel5.setLayout(new java.awt.GridLayout(7, 0));

    bundleNameLabel.setText("Bundle Name:");
    jPanel5.add(bundleNameLabel);

    bundleNameTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    bundleNameTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(bundleNameTextField);

    nodeNameLabel.setText("Node name:");
    jPanel5.add(nodeNameLabel);

    nodeNameTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    nodeNameTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(nodeNameTextField);

    numberOfLicencesLabel.setText("Number of Licences (leave empty for 'all'/'no licences'):");
    jPanel5.add(numberOfLicencesLabel);

    numberOfLicencesTextField.setMinimumSize(new java.awt.Dimension(200, 21));
    numberOfLicencesTextField.setPreferredSize(new java.awt.Dimension(200, 21));
    jPanel5.add(numberOfLicencesTextField);

    warnLabel.setText("'Number of Licences' has no effect if Contract is present.");
    jPanel5.add(warnLabel);

    jPanel1.add(jPanel5, java.awt.BorderLayout.NORTH);

    jPanel4.add(jPanel1, java.awt.BorderLayout.CENTER);

    chooseBinaryBundleButton.setText("Choose Binary Bundle");
    chooseBinaryBundleButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        chooseBinaryBundleButtonActionPerformed(evt);
      }
    });

    jPanel2.add(chooseBinaryBundleButton);

    showLicenceButton.setText("Show Licence of Selected Bundle");
    showLicenceButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        showLicenceButtonActionPerformed(evt);
      }
    });

    jPanel2.add(showLicenceButton);

    jPanel4.add(jPanel2, java.awt.BorderLayout.NORTH);

    pushButton.setText("Push Bundle");
    pushButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        pushButtonActionPerformed(evt);
      }
    });

    jPanel3.add(pushButton);

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        cancelButtonActionPerformed(evt);
      }
    });

    jPanel3.add(cancelButton);

    jPanel4.add(jPanel3, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel4, java.awt.BorderLayout.CENTER);

    pack();
  }//GEN-END:initComponents

  private void showLicenceButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_showLicenceButtonActionPerformed
  {//GEN-HEADEREND:event_showLicenceButtonActionPerformed
    String bundleName = bundleNameTextField.getText();
    
    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromBundleName(bundleName);
    }
    catch (BundleInfo.InvalidBundleNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    Licence licence = null;    
    try
    {
      licence = admin.getLicence(bundleName);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    if (licence != null)
    {
      LicenceEditDialog.showDialog(this, licence, false, "Licence File of '" + bundleName + "'");
    }
    else
    {
      JOptionPane.showMessageDialog(this, "Bundle '" + bundleName + "' is not limited by licence", "No Licence File Present", JOptionPane.INFORMATION_MESSAGE);
    }
  }//GEN-LAST:event_showLicenceButtonActionPerformed

  private void chooseBinaryBundleButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_chooseBinaryBundleButtonActionPerformed
  {//GEN-HEADEREND:event_chooseBinaryBundleButtonActionPerformed
    String[] bundles = null;
    try
    {
      bundles = admin.binBundlesList();
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, "RMI Error occured while accessing SOFA net node:\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    Arrays.sort(bundles);
    
    String result = ListDialog.showDialog(this, this, "Binary Bundles:", "Choose Binary Bundle to Push", bundles, null, null, false, true);
    if (result.length() != 0) bundleNameTextField.setText(result);
    
  }//GEN-LAST:event_chooseBinaryBundleButtonActionPerformed

  private void pushButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_pushButtonActionPerformed
  {//GEN-HEADEREND:event_pushButtonActionPerformed
    String bundleName = bundleNameTextField.getText();
    String nodeName = nodeNameTextField.getText();
    String numberOfLicencesText = numberOfLicencesTextField.getText().trim();
    
    BundleInfo bundleInfo = new BundleInfo();
    try
    {
      bundleInfo.fromBundleName(bundleName);
    }
    catch (BundleInfo.InvalidBundleNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    NodeInfo nodeInfo = new NodeInfo();
    try
    {
      nodeInfo.setNodeName(nodeName);
    }
    catch (NodeInfo.InvalidNodeNameException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid name of SOFA node:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    int numberOfLicences = Licence.ALL_LICENCES;
    if (numberOfLicencesText.length() != 0)
    {
      try
      {
        numberOfLicences = Integer.parseInt(numberOfLicencesText);
        if (numberOfLicences < 0) throw new NumberFormatException("Negative 'Number of Licences' is not allowed");
      }
      catch (NumberFormatException e)
      {
        JOptionPane.showMessageDialog(this, "Error occured while parsing 'Number of Copies':\n" + e, "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
    }
    
    try
    {
      admin.pushBundle(bundleName, nodeName, numberOfLicences);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    
    JOptionPane.showMessageDialog(this, "Bundle '" + bundleName + "' has been scheduled to push to node '" + nodeName + "'");
    
    isOK = true;
    dispose();
  }//GEN-LAST:event_pushButtonActionPerformed

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cancelButtonActionPerformed
  {//GEN-HEADEREND:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel bundleNameLabel;
  private javax.swing.JTextField bundleNameTextField;
  private javax.swing.JButton cancelButton;
  private javax.swing.JButton chooseBinaryBundleButton;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel5;
  private javax.swing.JLabel nodeNameLabel;
  private javax.swing.JTextField nodeNameTextField;
  private javax.swing.JLabel numberOfLicencesLabel;
  private javax.swing.JTextField numberOfLicencesTextField;
  private javax.swing.JButton pushButton;
  private javax.swing.JButton showLicenceButton;
  private javax.swing.JLabel warnLabel;
  // End of variables declaration//GEN-END:variables
  
}
