/*
 * SearchDialog.java
 *
 * Created on 13. kvten 2004, 15:47
 */

package SOFA.SOFAnet.Browser;

import SOFA.SOFAnet.Admin.RMI.*;
import SOFA.SOFAnet.Search.*;
import SOFA.SOFAnet.Repository.BundleInfo;
import javax.swing.*;
import java.rmi.RemoteException;
import java.util.*;
import java.awt.Component;
import java.awt.Frame;

/**
 *
 * @author  Ladislav Sobr
 */
public class SearchDialog extends javax.swing.JDialog
{
  private DefaultListModel content;
  private RMIAdminInterface admin;
  
  public static void showDialog(Component frameComp, RMIAdminInterface admin)
  {
    Frame frame = JOptionPane.getFrameForComponent(frameComp);
    JDialog dialog = new SearchDialog(frame, true, admin);
    dialog.setLocationRelativeTo(frameComp);
    dialog.setVisible(true);
  }
  
  /** Creates new form SearchDialog */
  public SearchDialog(java.awt.Frame parent, boolean modal, RMIAdminInterface admin)
  {
    super(parent, modal);
    this.admin = admin;
    content = new DefaultListModel();
    initComponents();
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents()//GEN-BEGIN:initComponents
  {
    componentModeButtonGroup = new javax.swing.ButtonGroup();
    jPanel1 = new javax.swing.JPanel();
    jPanel7 = new javax.swing.JPanel();
    jPanel6 = new javax.swing.JPanel();
    strLabel = new javax.swing.JLabel();
    strTextField = new javax.swing.JTextField();
    patternCheckBox = new javax.swing.JCheckBox();
    componentCheckBox = new javax.swing.JCheckBox();
    componentModePanel = new javax.swing.JPanel();
    ccTryRadioButton = new javax.swing.JRadioButton();
    ccNoRadioButton = new javax.swing.JRadioButton();
    ccOnlyRadioButton = new javax.swing.JRadioButton();
    jPanel9 = new javax.swing.JPanel();
    settingsPanel = new javax.swing.JPanel();
    timoutLabel = new javax.swing.JLabel();
    timeoutTextField = new javax.swing.JTextField();
    shareGroupLabel = new javax.swing.JLabel();
    shareGroupTextField = new javax.swing.JTextField();
    firstOnlyCheckBox = new javax.swing.JCheckBox();
    jPanel8 = new javax.swing.JPanel();
    searchButton = new javax.swing.JButton();
    jPanel2 = new javax.swing.JPanel();
    jScrollPane1 = new javax.swing.JScrollPane();
    repliesList = new javax.swing.JList();
    jPanel4 = new javax.swing.JPanel();
    acquireButton = new javax.swing.JButton();
    jPanel3 = new javax.swing.JPanel();
    closeButton = new javax.swing.JButton();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Search");
    jPanel1.setLayout(new java.awt.BorderLayout());

    jPanel7.setLayout(new java.awt.BorderLayout());

    jPanel7.setBorder(new javax.swing.border.TitledBorder("Search Request"));
    jPanel6.setLayout(new java.awt.GridLayout(4, 0));

    strLabel.setText("Search String:");
    jPanel6.add(strLabel);

    jPanel6.add(strTextField);

    patternCheckBox.setText("Search String is Pattern");
    jPanel6.add(patternCheckBox);

    componentCheckBox.setText("Search String is Component");
    componentCheckBox.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        componentCheckBoxActionPerformed(evt);
      }
    });

    jPanel6.add(componentCheckBox);

    jPanel7.add(jPanel6, java.awt.BorderLayout.NORTH);

    componentModePanel.setLayout(new java.awt.GridLayout(3, 0));

    componentModePanel.setBorder(new javax.swing.border.TitledBorder("Component Mode"));
    componentModePanel.setEnabled(false);
    ccTryRadioButton.setSelected(true);
    ccTryRadioButton.setText("Try Complete Component (including subcomponents)");
    componentModeButtonGroup.add(ccTryRadioButton);
    ccTryRadioButton.setEnabled(false);
    componentModePanel.add(ccTryRadioButton);

    ccNoRadioButton.setText("Single Component (without subcomponents)");
    componentModeButtonGroup.add(ccNoRadioButton);
    ccNoRadioButton.setEnabled(false);
    componentModePanel.add(ccNoRadioButton);

    ccOnlyRadioButton.setText("Complete Component (with subcomponents)");
    componentModeButtonGroup.add(ccOnlyRadioButton);
    ccOnlyRadioButton.setEnabled(false);
    componentModePanel.add(ccOnlyRadioButton);

    jPanel7.add(componentModePanel, java.awt.BorderLayout.CENTER);

    jPanel1.add(jPanel7, java.awt.BorderLayout.CENTER);

    jPanel9.setLayout(new java.awt.BorderLayout());

    settingsPanel.setLayout(new java.awt.GridLayout(5, 0));

    settingsPanel.setBorder(new javax.swing.border.TitledBorder("Search Settings"));
    timoutLabel.setText("Timeout (in milliseconds):");
    settingsPanel.add(timoutLabel);

    timeoutTextField.setText("3000");
    settingsPanel.add(timeoutTextField);

    shareGroupLabel.setText("Share Group:");
    settingsPanel.add(shareGroupLabel);

    settingsPanel.add(shareGroupTextField);

    firstOnlyCheckBox.setSelected(true);
    firstOnlyCheckBox.setText("First Reply Only");
    settingsPanel.add(firstOnlyCheckBox);

    jPanel9.add(settingsPanel, java.awt.BorderLayout.NORTH);

    searchButton.setText("Search");
    searchButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        searchButtonActionPerformed(evt);
      }
    });

    jPanel8.add(searchButton);

    jPanel9.add(jPanel8, java.awt.BorderLayout.SOUTH);

    jPanel1.add(jPanel9, java.awt.BorderLayout.EAST);

    getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);

    jPanel2.setLayout(new java.awt.BorderLayout());

    jPanel2.setBorder(new javax.swing.border.TitledBorder("Replies"));
    repliesList.setModel(content);
    repliesList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    repliesList.addMouseListener(new java.awt.event.MouseAdapter()
    {
      public void mouseClicked(java.awt.event.MouseEvent evt)
      {
        repliesListMouseClicked(evt);
      }
    });

    jScrollPane1.setViewportView(repliesList);

    jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);

    acquireButton.setText("Acquire Selected Shared Bundle");
    acquireButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        acquireButtonActionPerformed(evt);
      }
    });

    jPanel4.add(acquireButton);

    jPanel2.add(jPanel4, java.awt.BorderLayout.SOUTH);

    getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

    closeButton.setText("Close");
    closeButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(java.awt.event.ActionEvent evt)
      {
        closeButtonActionPerformed(evt);
      }
    });

    jPanel3.add(closeButton);

    getContentPane().add(jPanel3, java.awt.BorderLayout.SOUTH);

    pack();
  }//GEN-END:initComponents

  private void repliesListMouseClicked(java.awt.event.MouseEvent evt)//GEN-FIRST:event_repliesListMouseClicked
  {//GEN-HEADEREND:event_repliesListMouseClicked
    if (evt.getClickCount() == 2)
    {
      acquireButton.doClick(); //emulate button click
    }
  }//GEN-LAST:event_repliesListMouseClicked

  private void closeButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_closeButtonActionPerformed
  {//GEN-HEADEREND:event_closeButtonActionPerformed
    dispose();
  }//GEN-LAST:event_closeButtonActionPerformed

  private void acquireButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_acquireButtonActionPerformed
  {//GEN-HEADEREND:event_acquireButtonActionPerformed
    SearchReplyItem reply = (SearchReplyItem)repliesList.getSelectedValue();
    if (reply != null)
    {
      AcquireSharedBundleDialog.showDialog(this, admin, reply.getBundleName(), reply.getNodeName());
    }
  }//GEN-LAST:event_acquireButtonActionPerformed

  private void searchButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_searchButtonActionPerformed
  {//GEN-HEADEREND:event_searchButtonActionPerformed
    String strText = strTextField.getText().trim();
    boolean pattern = patternCheckBox.isSelected();
    boolean component = componentCheckBox.isSelected();
    int completeComponent = SearchPattern.CC_TRY;
    if (ccNoRadioButton.isSelected()) completeComponent = SearchPattern.CC_NO;
    if (ccOnlyRadioButton.isSelected()) completeComponent = SearchPattern.CC_ONLY;

    if (strText.length() == 0)
    {
      JOptionPane.showMessageDialog(this, "Empty Search String", "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }
    
    if (!pattern)
    {
      BundleInfo bundleInfo = new BundleInfo();
      try
      {
        bundleInfo.fromBundleName(strText);
      }
      catch (BundleInfo.InvalidBundleNameException e)
      {
        if (component) JOptionPane.showMessageDialog(this, "Invalid name of component:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        else JOptionPane.showMessageDialog(this, "Invalid name of bundle:\n" + e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }

      if (component && !bundleInfo.isComponent())
      {
        JOptionPane.showMessageDialog(this, "Invalid name of component", "Error", JOptionPane.ERROR_MESSAGE);
        return;
      }
    }
    
    int timeout = 3000;
    try
    {
      timeout = Integer.parseInt(timeoutTextField.getText());
      if (timeout <= 0) throw new NumberFormatException();
    }
    catch (NumberFormatException e)
    {
      JOptionPane.showMessageDialog(this, "Invalid Timeout", "Error", JOptionPane.ERROR_MESSAGE);
      return;
    }

    String shareGroup = shareGroupTextField.getText();
    boolean firstOnly = firstOnlyCheckBox.isSelected();
    
    SearchPattern searchPattern = new SearchPattern();
    searchPattern.setStr(strText);
    searchPattern.setPattern(pattern);
    searchPattern.setComponent(component);
    searchPattern.setCompleteComponent(completeComponent);
    
    SearchReplyItem[] replies = null;
    try
    {
      replies = admin.search(searchPattern, firstOnly, shareGroup, timeout);
    }
    catch (RemoteException e)
    {
      JOptionPane.showMessageDialog(this, e, "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }
    catch (RMIAdminException e)
    {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
      dispose();
      return;
    }

    content.clear();
    if (replies != null)
    {
      content.ensureCapacity(replies.length);
      for (int i = 0; i < replies.length; i++) content.addElement(replies[i]);
    }
  }//GEN-LAST:event_searchButtonActionPerformed

  private void componentCheckBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_componentCheckBoxActionPerformed
  {//GEN-HEADEREND:event_componentCheckBoxActionPerformed
    boolean component = componentCheckBox.isSelected();
    componentModePanel.setEnabled(component);
    ccTryRadioButton.setEnabled(component);
    ccNoRadioButton.setEnabled(component);
    ccOnlyRadioButton.setEnabled(component);
  }//GEN-LAST:event_componentCheckBoxActionPerformed
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton acquireButton;
  private javax.swing.JRadioButton ccNoRadioButton;
  private javax.swing.JRadioButton ccOnlyRadioButton;
  private javax.swing.JRadioButton ccTryRadioButton;
  private javax.swing.JButton closeButton;
  private javax.swing.JCheckBox componentCheckBox;
  private javax.swing.ButtonGroup componentModeButtonGroup;
  private javax.swing.JPanel componentModePanel;
  private javax.swing.JCheckBox firstOnlyCheckBox;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JPanel jPanel6;
  private javax.swing.JPanel jPanel7;
  private javax.swing.JPanel jPanel8;
  private javax.swing.JPanel jPanel9;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JCheckBox patternCheckBox;
  private javax.swing.JList repliesList;
  private javax.swing.JButton searchButton;
  private javax.swing.JPanel settingsPanel;
  private javax.swing.JLabel shareGroupLabel;
  private javax.swing.JTextField shareGroupTextField;
  private javax.swing.JLabel strLabel;
  private javax.swing.JTextField strTextField;
  private javax.swing.JTextField timeoutTextField;
  private javax.swing.JLabel timoutLabel;
  // End of variables declaration//GEN-END:variables
  
}
