/*
 * RMISearchInterface.java
 *
 * Created on 29. duben 2004, 13:23
 */

package SOFA.SOFAnet.Search.RMI;

import java.rmi.Remote;
import java.rmi.RemoteException;
import SOFA.SOFAnet.Search.*;
import SOFA.SOFAnet.Repository.ShareGroups;

/**
 * Remote interface of RMI implementation of search subsystem.
 * @author  Ladislav Sobr
 */
public interface RMISearchInterface extends Remote
{
  void connect(String nodeName, ShareGroups shareGroups) throws RMISearchException, RemoteException;
  void request(String nodeName, SearchRequestID requestID, SearchPattern searchPattern, boolean firstOnly, String shareGroup) throws RMISearchException, RemoteException;
  void reply(String nodeName, SearchReply searchReply) throws RMISearchException, RemoteException;
}
