/*
 * SearchReplyItem.java
 *
 * Created on 28. duben 2004, 15:35
 */

package SOFA.SOFAnet.Search;

import java.io.Serializable;

/**
 * The reply item is par of node name and bundle name - which node and which bundle can satisfy search request
 *
 * @author  Ladislav Sobr
 */
public class SearchReplyItem implements Serializable
{
  private String nodeName;
  private String bundleName;
  
  /** Creates a new instance of SearchReplyItem */
  public SearchReplyItem()
  {
  }

  public SearchReplyItem(String nodeName, String bundleName)
  {
    this.nodeName = nodeName;
    this.bundleName = bundleName;
  }

  public String getNodeName()
  {
    return nodeName;
  }
  
  public String getBundleName()
  {
    return bundleName;
  }
  
  public void setNodeName(String nodeName)
  {
    this.nodeName = nodeName;
  }
  
  public void setBundleName(String bundleName)
  {
    this.bundleName = bundleName;
  }
  
  public String toString()
  {
    return bundleName + " at " + nodeName;
  }
}
