/*
 * TRWrapper.java
 *
 * Created on 19. bezen 2004, 17:00
 */

package SOFA.SOFAnet.TR.Local;

import SOFA.SOFAnode.TR.*;
import SOFA.SOFAnode.InOut.Bundle;
import SOFA.SOFAnet.TR.TRInterface;
import SOFA.SOFAnode.TR.Impl.*;
import java.rmi.RemoteException;
import java.io.IOException;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;

/**
 * Wrapper of TR implementation.
 *
 * @author  Ladislav Sobr
 */
public class TRWrapper implements TRInterface
{
  private TRImpl tr;
  
  /** Creates a new instance of TRWrapper */
  public TRWrapper(String dir) throws TRException
  {
    try
    {
      tr = new TRImpl(dir);
    }
    catch (RemoteException e)
    {
      throw new TRException ("TR init failed", e);
    }
  }
  
  public boolean contains(ComponentInfo descrs)
  {
    return tr.contains(descrs);
  }
  
  public boolean containsComponent(ComponentInfo comp, boolean inferiors)
  {
    return tr.containsComponent(comp, inferiors);
  }

  public void deleteComponents(ComponentInfo[] comps, boolean interfaces, boolean inferiors) throws TRException
  {
    tr.deleteComponents(comps, interfaces, inferiors);
  }
  
  public Bundle getBundle(ComponentInfo[] descs, ComponentInfo[] comps, boolean inferiors) throws TRException
  {
    return tr.getBundle(descs, comps, inferiors);
  }
  
  public byte[] getMemoryBundle(ComponentInfo[] descs, ComponentInfo[] comps, boolean inferiors) throws TRException
  {
    BundleImpl bundle = (BundleImpl) tr.getBundle(descs, comps, inferiors);

    byte[] ret = null;

    try
    {
      ByteArrayOutputStream os = new ByteArrayOutputStream();
      bundle._write(os);
      os.close();
      ret = os.toByteArray();
    }
    catch (IOException e)
    {
      throw new TRException("Serialization of bundle while getting bundle in TRWrapper failed", e);
    }

    return ret;
  }
  
  public Bundle list()
  {
    return tr.list();
  }
  
  public void storeBundle(Bundle bundle) throws TRException
  {
    tr.storeBundle(bundle);
  }
  
  public void storeMemoryBundle(byte[] memoryBundle) throws TRException
  {
    BundleImpl bundle = new BundleImpl();
    try
    {
      bundle._read(new ByteArrayInputStream(memoryBundle));
    }
    catch (IOException e)
    {
      throw new TRException("Serialization of bundle while storing bundle in TRWrapper failed", e);
    }

    tr.storeBundle(bundle);
  }
}
