/*
 * RMITransportInterface.java
 *
 * Created on 7. duben 2004, 17:19
 */

package SOFA.SOFAnet.Transport.RMI;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Remote interface of RMI implementation of transport layer.
 *
 * @author  Ladislav Sobr
 */
public interface RMITransportInterface extends Remote
{
  void push(String nodeName, String bundleName, byte[] bundle, LicenceRMI licenceRMI, boolean offer) throws RMITransportException, RemoteException;
  boolean testPush(String nodeName, String bundleName, boolean offer) throws RMITransportException, RemoteException;
  boolean testPull(String nodeName, String bundleName, boolean sharing, String contractID) throws RMITransportException, RemoteException;
  RMIPullOutputHolder pull(String nodeName, String bundleName, boolean sharing, boolean licenceOnly, String contractID) throws RMITransportException, RemoteException;
  boolean canReturnShared(String nodeName, String bundleName) throws RMITransportException, RemoteException;
  int returnShared(String nodeName, String bundleName, boolean address, String addressNodeName) throws RMITransportException, RemoteException;
  int manualReturnShared(String nodeName, String bundleName) throws RMITransportException, RemoteException;
}
