/* $Id: CompFixed.java,v 1.2 2004/05/20 14:23:51 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
import java.rmi.RemoteException;

import SOFA.SOFAnode.Made.TIR.CDLRepository;
import SOFA.SOFAnode.Made.TIR.CDLType;
import SOFA.SOFAnode.Made.TIR.TIRExceptCreate;

class CompFixed extends CompObjectIm implements CompType {
  public CompExprOper digits;
  public CompExprOper scale;

  public CompFixed(CompExprOper dig, CompExprOper sc) {
    super(ObjectsKind.o_Fixed);
    digits = dig;
    scale = sc;
  }

  public CompFixed() {
    super(ObjectsKind.o_Fixed);
    digits = null;
    scale = null;
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    if (!CompExprOper.testPropInExpr(props, digits.nameProp(rep)))
      throw new CDLExceptCheck("Unknown property");
    if (!CompExprOper.testPropInExpr(props, scale.nameProp(rep)))
      throw new CDLExceptCheck("Unknown property");
  }

  public CDLType toNormal(CDLRepository newRep) throws CDLExceptRemote, CDLExceptToNormal, CDLExceptLock {
    try {
      return newRep.create_fixed(digits.toNormal(newRep), scale.toNormal(newRep));
    } catch (RemoteException e) {
      throw new CDLExceptRemote("Remote exception occured: "+e.getMessage());
    } catch (TIRExceptCreate e) {
      throw new CDLExceptToNormal("Can't get primitve type\n"+e.getMessage());
    }
  }
}
