/* $Id: CompRequire.java,v 1.1.1.1 2003/02/11 16:19:40 bures Exp $ */
package SOFA.SOFAnode.Made.CDL;
 
class CompRequire extends CompContainedIm {
  CompReffer type;
  EnumList operations;
  String typeCode;
  
  public CompRequire(ID id, CompContainer in, CompRepository inRep, CompReffer t, EnumList op, String tC) {
    super(ObjectsKind.o_Requires, id, in, inRep);
    id.version = ((CompContained) in).getIdent().version;
    type = t;
    operations = op;
    typeCode = tC;
//    Debug.message("Vytvarim require: "+id);
  }

  public void checkConsist(EnumList props, CompRepository rep) throws CDLExceptCheck, CDLExceptLock, CDLExceptRemote {
    type.checkConsist(props, rep);
  }

  public boolean isOperation(String name) {
    return operations.isIn(name);
  }

  public boolean containsArray() {
    if (typeCode.indexOf('a')!=-1)
      return true;
    return false;
  }

  /** Returns interface protocol adjusted to frame (add ?/! and instantion of iface).
      <b>Return values:</b><br>
      <ol><li>string with protocol</li><li><i>null</i>, if reffers array, or no protocol exists</li></ol>  */
  public String ifaceProtocol()  throws CDLExceptLock, CDLExceptRemote {
    if (typeCode.indexOf('a')==-1) 
      return CompProvide.realIfaceProtocol(type, "!", id.name, rep);
    else {
      CompReffer r = CompProvide.getProvReqIface(type.ref, rep);
      if (r!=null)
        return CompProvide.realIfaceProtocol(r, "!", id.name, rep);
      else
        return null;
    }
  }
}
