/* $Id: KillAll.java,v 1.2 2004/05/20 14:23:52 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Access.Browser;
import java.rmi.Naming;

import SOFA.SOFAnode.Made.TIR.ManageRepository;
import SOFA.SOFAnode.Made.TIR.WorkRepository;

/** Abort all active work repositories */
public class KillAll {
  public static void main(String[] argv) {
    try {
      System.setSecurityManager(new java.rmi.RMISecurityManager());
    
      String rmiport = System.getProperty("sofa.rmiport","1099");
      String rmihost = System.getProperty("sofa.rmihost","localhost");
      ManageRepository rep = (ManageRepository) Naming.lookup("//"+rmihost+":"+rmiport+"/Repository");
      
      WorkRepository[] wr = rep.getActiveWork();

      if (wr.length==0) {
        System.out.println("No active");
        return;
      }
      for(int i=0;i<wr.length;i++) {
        System.out.print("Aborting "+wr[i].workIdent()+"...");
        if (wr[i].abort())
          System.out.println("OK");
        else
          System.out.println("Error!");
      }

      
    } catch (Exception e) { 
      System.out.println("Exception: " + e.getMessage()); 
      e.printStackTrace(); 
    }
  }
}
