/* $Id: ExprFixedImpl.java,v 1.2 2004/05/20 14:23:52 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import java.io.IOException;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import SOFA.SOFAnode.Made.TIR.Container;
import SOFA.SOFAnode.Made.TIR.DefinitionKind;
import SOFA.SOFAnode.Made.TIR.ExprFixed;
import SOFA.SOFAnode.Made.TIR.ExprOperDef;
import SOFA.SOFAnode.Made.TIR.ExprOperKind;
import SOFA.SOFAnode.Made.TIR.Repository;
import SOFA.SOFAnode.Made.TIR.StateKind;
import SOFA.SOFAnode.Made.TIR.TIRExceptCommit;

public class ExprFixedImpl extends UnicastRemoteObject implements ExprFixed, TIRImplObject {
  java.math.BigDecimal v;
  int dig;
  int sc;
  ExprOperKindImpl eok;
  DefinitionKindImpl defKindImpl;
  StateKindImpl stKindImpl; 

  public ExprFixedImpl(java.math.BigDecimal value, int digits, int scale) throws RemoteException {
    v = value;
    dig = digits;
    sc = scale;
    eok = new ExprOperKindImpl(ExprOperKind.eok_fixed);
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_Expression);
    stKindImpl = new StateKindImpl(StateKind.sk_work);
  }

  public ExprFixedImpl()  throws RemoteException {
    v = null;
    dig = 0;
    sc = 0;
    eok = new ExprOperKindImpl(ExprOperKind.eok_fixed);
    defKindImpl = new DefinitionKindImpl(DefinitionKind.dk_Expression);
    stKindImpl = new StateKindImpl(StateKind.sk_normal);
  }

  /* from interface TIRObject */
  public DefinitionKind get_def_kind() throws RemoteException {
    return (DefinitionKind) defKindImpl;
  }

  /* from interface TIRObject */
  public StateKind get_state() throws RemoteException {
    return (StateKind) stKindImpl;
  }

  public java.math.BigDecimal value() throws RemoteException {
    return v;
  }
  
  public int digits() throws RemoteException {
    return dig;
  }
  
  public int scale() throws RemoteException {
    return sc;
  }

  public ExprOperKind get_eok_kind() throws RemoteException {
    return (ExprOperKind) eok;
  }
  
  public ExprOperDef calculate() throws RemoteException {
    return this;
  }

  public void save(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      st.curOutFile.writeInt(eok.value());
      Storage.writeString(st.curOutFile,v.toString());
      st.curOutFile.writeInt(dig);
      st.curOutFile.writeInt(sc);
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't write in file "+st.currentFile+".");
    }
  }
  
  public void load(Storage st) throws RemoteException, TIRExceptStorage {
    try {
      String s = Storage.readString(st.curInFile);
      v = new java.math.BigDecimal(s);
      dig = st.curInFile.readInt();   
      sc = st.curInFile.readInt();
    } catch (IOException e) {
      throw new TIRExceptStorage("Can't read in file "+st.currentFile+".");
    }
  }

  public void postLoad(RepositoryImpl r) throws RemoteException, TIRExceptStorage {
    ;
  }

  public boolean isNew() {
    return (stKindImpl.value()==StateKind.sk_work);
  }

  public void canCommit() throws RemoteException, TIRExceptCommit {;}

  public void doCommit(Container in, Repository rep) throws RemoteException {
    if (stKindImpl.value()==StateKind.sk_work)
      stKindImpl.toNormal();
  }

  public void doAbort(long workId) throws RemoteException {}
}
