/* $Id: ExprHelp.java,v 1.2 2004/05/20 14:23:52 bures Exp $ */
package SOFA.SOFAnode.Made.TIR.Impl;
import java.rmi.RemoteException;

import SOFA.SOFAnode.Made.TIR.ExprBinOperationDef;
import SOFA.SOFAnode.Made.TIR.ExprBoolean;
import SOFA.SOFAnode.Made.TIR.ExprChar;
import SOFA.SOFAnode.Made.TIR.ExprConstant;
import SOFA.SOFAnode.Made.TIR.ExprDouble;
import SOFA.SOFAnode.Made.TIR.ExprEnum;
import SOFA.SOFAnode.Made.TIR.ExprFixed;
import SOFA.SOFAnode.Made.TIR.ExprFloat;
import SOFA.SOFAnode.Made.TIR.ExprLong;
import SOFA.SOFAnode.Made.TIR.ExprLongLong;
import SOFA.SOFAnode.Made.TIR.ExprOctet;
import SOFA.SOFAnode.Made.TIR.ExprOperDef;
import SOFA.SOFAnode.Made.TIR.ExprOperKind;
import SOFA.SOFAnode.Made.TIR.ExprProperty;
import SOFA.SOFAnode.Made.TIR.ExprShort;
import SOFA.SOFAnode.Made.TIR.ExprString;
import SOFA.SOFAnode.Made.TIR.ExprUnOperationDef;
import SOFA.SOFAnode.Made.TIR.ExprUnsigLong;
import SOFA.SOFAnode.Made.TIR.ExprUnsigLongLong;
import SOFA.SOFAnode.Made.TIR.ExprUnsigShort;
import SOFA.SOFAnode.Made.TIR.ExprWchar;
import SOFA.SOFAnode.Made.TIR.ExprWstring;
import SOFA.SOFAnode.Made.TIR.StateKind;
import SOFA.SOFAnode.Made.TIR.TIRExceptCalculate;
import SOFA.SOFAnode.Made.TIR.ValueGen;
import SOFA.SOFAnode.Made.TIR.ValueGenElement;

/** some useful functions for calculate expressions */
public class ExprHelp {
  private static int max(int a, int b) {
    return (a<b)?b:a;
  }

  public static ExprOperDef plus(ExprOperDef a, ExprOperDef b) throws RemoteException, TIRExceptCalculate {
    switch (a.get_eok_kind().value()) {
    case ExprOperKind.eok_short:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprShort)a).value()+((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprShort)a).value()+((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprShort)a).value()+((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()+((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprShort)a).value()+((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprShort)a).value()+((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprShortImpl((short)((((ExprShort)a).value()+((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_long:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongImpl((((ExprLong)a).value()+((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprLong)a).value()+((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLong)a).value()+((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongImpl(((((ExprLong)a).value()+((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprLong)a).value()+((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLong)a).value()+((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongImpl((((ExprLong)a).value()+((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_longlong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongLongImpl((((ExprLongLong)a).value()+((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongLongImpl((((ExprLongLong)a).value()+((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()+((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongLongImpl(((((ExprLongLong)a).value()+((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()+((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLongLong)a).value()+((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongLongImpl((((ExprLongLong)a).value()+((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsigshort:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigShortImpl((short)(((ExprUnsigShort)a).value()+((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprUnsigShort)a).value()+((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigShort)a).value()+((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()+((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigShort)a).value()+((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigShort)a).value()+((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()+((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()+((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()+((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigLong)a).value()+((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongImpl(((((ExprUnsigLong)a).value()+((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()+((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLong)a).value()+((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()+((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglonglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()+((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()+((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()+((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongLongImpl(((((ExprUnsigLongLong)a).value()+((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()+((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()+((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()+((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_octet:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprOctet)a).value()+((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprOctet)a).value()+((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprOctet)a).value()+((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()+((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprOctet)a).value()+((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprOctet)a).value()+((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprOctetImpl((byte)((((ExprOctet)a).value()+((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_float:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_float:
        return new ExprFloatImpl(((ExprFloat)a).value()+((ExprFloat)b).value());
      case ExprOperKind.eok_double:
        return new ExprDoubleImpl(((ExprFloat)a).value()+((ExprDouble)b).value());
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_double:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_float:
        return new ExprDoubleImpl(((ExprDouble)a).value()+((ExprFloat)b).value());
      case ExprOperKind.eok_double:
        return new ExprDoubleImpl(((ExprDouble)a).value()+((ExprDouble)b).value());
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_fixed:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_fixed:
        int d1 = ((ExprFixed)a).digits();
        int s1 = ((ExprFixed)a).scale();
        int d2 = ((ExprFixed)b).digits();
        int s2 = ((ExprFixed)b).scale();
        int d = max(d1-s1,d2-s2)+max(s1,s2)+1;
        int s = max(s1,s2);
        if (d>31) {
          d = 31; s = 31-d+s;
        }
        return new ExprFixedImpl(((ExprFixed)a).value().add(((ExprFixed)b).value()),d,s);
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }
    default:  throw new TIRExceptCalculate("Can't calculate.");  
    }
  }

  public static ExprOperDef minus(ExprOperDef a, ExprOperDef b) throws RemoteException, TIRExceptCalculate {
    switch (a.get_eok_kind().value()) {
    case ExprOperKind.eok_short:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprShort)a).value()-((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprShort)a).value()-((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprShort)a).value()-((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()-((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprShort)a).value()-((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprShort)a).value()-((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprShortImpl((short)((((ExprShort)a).value()-((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_long:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongImpl((((ExprLong)a).value()-((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprLong)a).value()-((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLong)a).value()-((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongImpl(((((ExprLong)a).value()-((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprLong)a).value()-((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLong)a).value()-((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongImpl((((ExprLong)a).value()-((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_longlong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongLongImpl((((ExprLongLong)a).value()-((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongLongImpl((((ExprLongLong)a).value()-((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()-((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongLongImpl(((((ExprLongLong)a).value()-((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()-((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLongLong)a).value()-((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongLongImpl((((ExprLongLong)a).value()-((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsigshort:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigShortImpl((short)(((ExprUnsigShort)a).value()-((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprUnsigShort)a).value()-((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigShort)a).value()-((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()-((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigShort)a).value()-((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigShort)a).value()-((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()-((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()-((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()-((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigLong)a).value()-((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongImpl(((((ExprUnsigLong)a).value()-((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()-((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLong)a).value()-((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()-((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglonglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()-((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()-((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()-((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongLongImpl(((((ExprUnsigLongLong)a).value()-((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()-((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()-((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()-((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_octet:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprOctet)a).value()-((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprOctet)a).value()-((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprOctet)a).value()-((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()-((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprOctet)a).value()-((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprOctet)a).value()-((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprOctetImpl((byte)((((ExprOctet)a).value()-((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_float:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_float:
        return new ExprFloatImpl(((ExprFloat)a).value()-((ExprFloat)b).value());
      case ExprOperKind.eok_double:
        return new ExprDoubleImpl(((ExprFloat)a).value()-((ExprDouble)b).value());
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_double:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_float:
        return new ExprDoubleImpl(((ExprDouble)a).value()-((ExprFloat)b).value());
      case ExprOperKind.eok_double:
        return new ExprDoubleImpl(((ExprDouble)a).value()-((ExprDouble)b).value());
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_fixed:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_fixed:
        int d1 = ((ExprFixed)a).digits();
        int s1 = ((ExprFixed)a).scale();
        int d2 = ((ExprFixed)b).digits();
        int s2 = ((ExprFixed)b).scale();
        int d = max(d1-s1,d2-s2)+max(s1,s2)+1;
        int s = max(s1,s2);
        if (d>31) {
          d = 31; s = 31-d+s;
        }
        return new ExprFixedImpl(((ExprFixed)a).value().subtract(((ExprFixed)b).value()),d,s);
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }
    default:  throw new TIRExceptCalculate("Can't calculate.");  
    }
  }

  public static ExprOperDef mul(ExprOperDef a, ExprOperDef b) throws RemoteException, TIRExceptCalculate {
    switch (a.get_eok_kind().value()) {
    case ExprOperKind.eok_short:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprShort)a).value()*((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprShort)a).value()*((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprShort)a).value()*((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()*((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprShort)a).value()*((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprShort)a).value()*((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprShortImpl((short)((((ExprShort)a).value()*((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_long:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongImpl((((ExprLong)a).value()*((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprLong)a).value()*((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLong)a).value()*((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongImpl(((((ExprLong)a).value()*((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprLong)a).value()*((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLong)a).value()*((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongImpl((((ExprLong)a).value()*((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_longlong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongLongImpl((((ExprLongLong)a).value()*((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongLongImpl((((ExprLongLong)a).value()*((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()*((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongLongImpl(((((ExprLongLong)a).value()*((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()*((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLongLong)a).value()*((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongLongImpl((((ExprLongLong)a).value()*((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsigshort:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigShortImpl((short)(((ExprUnsigShort)a).value()*((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprUnsigShort)a).value()*((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigShort)a).value()*((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()*((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigShort)a).value()*((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigShort)a).value()*((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()*((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()*((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()*((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigLong)a).value()*((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongImpl(((((ExprUnsigLong)a).value()*((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()*((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLong)a).value()*((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()*((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglonglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()*((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()*((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()*((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongLongImpl(((((ExprUnsigLongLong)a).value()*((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()*((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()*((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()*((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_octet:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprOctet)a).value()*((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprOctet)a).value()*((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprOctet)a).value()*((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()*((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprOctet)a).value()*((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprOctet)a).value()*((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprOctetImpl((byte)((((ExprOctet)a).value()*((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_float:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_float:
        return new ExprFloatImpl(((ExprFloat)a).value()*((ExprFloat)b).value());
      case ExprOperKind.eok_double:
        return new ExprDoubleImpl(((ExprFloat)a).value()*((ExprDouble)b).value());
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_double:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_float:
        return new ExprDoubleImpl(((ExprDouble)a).value()*((ExprFloat)b).value());
      case ExprOperKind.eok_double:
        return new ExprDoubleImpl(((ExprDouble)a).value()*((ExprDouble)b).value());
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_fixed:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_fixed:
        int d1 = ((ExprFixed)a).digits();
        int s1 = ((ExprFixed)a).scale();
        int d2 = ((ExprFixed)b).digits();
        int s2 = ((ExprFixed)b).scale();
        int d = d1+d2;
        int s = s1+s2;
        if (d>31) {
          d = 31; s = 31-d+s;
        }
        return new ExprFixedImpl(((ExprFixed)a).value().multiply(((ExprFixed)b).value()),d,s);
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }
    default:  throw new TIRExceptCalculate("Can't calculate.");  
    }
  }

  public static ExprOperDef div(ExprOperDef a, ExprOperDef b) throws RemoteException, TIRExceptCalculate {
    switch (a.get_eok_kind().value()) {
    case ExprOperKind.eok_short:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprShort)a).value()/((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprShort)a).value()/((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprShort)a).value()/((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()/((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprShort)a).value()/((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprShort)a).value()/((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprShortImpl((short)((((ExprShort)a).value()/((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_long:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongImpl((((ExprLong)a).value()/((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprLong)a).value()/((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLong)a).value()/((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongImpl(((((ExprLong)a).value()/((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprLong)a).value()/((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLong)a).value()/((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongImpl((((ExprLong)a).value()/((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_longlong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongLongImpl((((ExprLongLong)a).value()/((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongLongImpl((((ExprLongLong)a).value()/((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()/((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongLongImpl(((((ExprLongLong)a).value()/((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()/((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLongLong)a).value()/((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongLongImpl((((ExprLongLong)a).value()/((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsigshort:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigShortImpl((short)(((ExprUnsigShort)a).value()/((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprUnsigShort)a).value()/((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigShort)a).value()/((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()/((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigShort)a).value()/((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigShort)a).value()/((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()/((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()/((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()/((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigLong)a).value()/((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongImpl(((((ExprUnsigLong)a).value()/((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()/((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLong)a).value()/((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()/((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglonglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()/((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()/((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()/((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongLongImpl(((((ExprUnsigLongLong)a).value()/((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()/((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()/((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()/((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_octet:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprOctet)a).value()/((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprOctet)a).value()/((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprOctet)a).value()/((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()/((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprOctet)a).value()/((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprOctet)a).value()/((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprOctetImpl((byte)((((ExprOctet)a).value()/((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_float:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_float:
        return new ExprFloatImpl(((ExprFloat)a).value()/((ExprFloat)b).value());
      case ExprOperKind.eok_double:
        return new ExprDoubleImpl(((ExprFloat)a).value()/((ExprDouble)b).value());
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_double:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_float:
        return new ExprDoubleImpl(((ExprDouble)a).value()/((ExprFloat)b).value());
      case ExprOperKind.eok_double:
        return new ExprDoubleImpl(((ExprDouble)a).value()/((ExprDouble)b).value());
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case  ExprOperKind.eok_fixed:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_fixed:
        int d1 = ((ExprFixed)a).digits();
        int s1 = ((ExprFixed)a).scale();
        int d2 = ((ExprFixed)b).digits();
        int s2 = ((ExprFixed)b).scale();
        int d = d1-s1+s2+Short.MAX_VALUE;
        int s = Short.MAX_VALUE;
        if (d>31) {
          d = 31; s = 31-d+s;
        }  
        return new ExprFixedImpl(((ExprFixed)a).value().divide(((ExprFixed)b).value(),s,java.math.BigDecimal.ROUND_HALF_UP),d,s);
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }
    default:  throw new TIRExceptCalculate("Can't calculate.");  
    }
  }

  public static ExprOperDef or(ExprOperDef a, ExprOperDef b) throws RemoteException, TIRExceptCalculate {
    switch (a.get_eok_kind().value()) {
    case ExprOperKind.eok_short:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprShort)a).value()|((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprShort)a).value()|((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprShort)a).value()|((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()|((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprShort)a).value()|((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprShort)a).value()|((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprShortImpl((short)((((ExprShort)a).value()|((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_long:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongImpl((((ExprLong)a).value()|((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprLong)a).value()|((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLong)a).value()|((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongImpl(((((ExprLong)a).value()|((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprLong)a).value()|((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLong)a).value()|((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongImpl((((ExprLong)a).value()|((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_longlong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongLongImpl((((ExprLongLong)a).value()|((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongLongImpl((((ExprLongLong)a).value()|((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()|((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongLongImpl(((((ExprLongLong)a).value()|((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()|((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLongLong)a).value()|((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongLongImpl((((ExprLongLong)a).value()|((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsigshort:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigShortImpl((short)(((ExprUnsigShort)a).value()|((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprUnsigShort)a).value()|((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigShort)a).value()|((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()|((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigShort)a).value()|((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigShort)a).value()|((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()|((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()|((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()|((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigLong)a).value()|((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongImpl(((((ExprUnsigLong)a).value()|((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()|((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLong)a).value()|((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()|((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglonglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()|((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()|((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()|((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongLongImpl(((((ExprUnsigLongLong)a).value()|((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()|((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()|((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()|((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_octet:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprOctet)a).value()|((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprOctet)a).value()|((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprOctet)a).value()|((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()|((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprOctet)a).value()|((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprOctet)a).value()|((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprOctetImpl((byte)((((ExprOctet)a).value()|((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    default:  throw new TIRExceptCalculate("Can't calculate.");  
    }
  }

  public static ExprOperDef xor(ExprOperDef a, ExprOperDef b) throws RemoteException, TIRExceptCalculate {
    switch (a.get_eok_kind().value()) {
    case ExprOperKind.eok_short:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprShort)a).value()^((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprShort)a).value()^((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprShort)a).value()^((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()^((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprShort)a).value()^((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprShort)a).value()^((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprShortImpl((short)((((ExprShort)a).value()^((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_long:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongImpl((((ExprLong)a).value()^((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprLong)a).value()^((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLong)a).value()^((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongImpl(((((ExprLong)a).value()^((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprLong)a).value()^((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLong)a).value()^((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongImpl((((ExprLong)a).value()^((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_longlong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongLongImpl((((ExprLongLong)a).value()^((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongLongImpl((((ExprLongLong)a).value()^((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()^((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongLongImpl(((((ExprLongLong)a).value()^((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()^((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLongLong)a).value()^((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongLongImpl((((ExprLongLong)a).value()^((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsigshort:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigShortImpl((short)(((ExprUnsigShort)a).value()^((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprUnsigShort)a).value()^((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigShort)a).value()^((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()^((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigShort)a).value()^((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigShort)a).value()^((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()^((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()^((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()^((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigLong)a).value()^((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongImpl(((((ExprUnsigLong)a).value()^((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()^((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLong)a).value()^((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()^((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglonglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()^((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()^((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()^((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongLongImpl(((((ExprUnsigLongLong)a).value()^((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()^((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()^((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()^((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_octet:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprOctet)a).value()^((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprOctet)a).value()^((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprOctet)a).value()^((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()^((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprOctet)a).value()^((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprOctet)a).value()^((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprOctetImpl((byte)((((ExprOctet)a).value()^((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    default:  throw new TIRExceptCalculate("Can't calculate.");  
    }
  }

  public static ExprOperDef and(ExprOperDef a, ExprOperDef b) throws RemoteException, TIRExceptCalculate {
    switch (a.get_eok_kind().value()) {
    case ExprOperKind.eok_short:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprShort)a).value()&((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprShort)a).value()&((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprShort)a).value()&((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()&((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprShort)a).value()&((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprShort)a).value()&((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprShortImpl((short)((((ExprShort)a).value()&((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_long:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongImpl((((ExprLong)a).value()&((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprLong)a).value()&((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLong)a).value()&((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongImpl(((((ExprLong)a).value()&((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprLong)a).value()&((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLong)a).value()&((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongImpl((((ExprLong)a).value()&((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_longlong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongLongImpl((((ExprLongLong)a).value()&((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongLongImpl((((ExprLongLong)a).value()&((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()&((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongLongImpl(((((ExprLongLong)a).value()&((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()&((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLongLong)a).value()&((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongLongImpl((((ExprLongLong)a).value()&((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsigshort:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigShortImpl((short)(((ExprUnsigShort)a).value()&((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprUnsigShort)a).value()&((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigShort)a).value()&((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()&((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigShort)a).value()&((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigShort)a).value()&((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()&((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()&((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()&((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigLong)a).value()&((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongImpl(((((ExprUnsigLong)a).value()&((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()&((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLong)a).value()&((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()&((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglonglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()&((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()&((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()&((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongLongImpl(((((ExprUnsigLongLong)a).value()&((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()&((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()&((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()&((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_octet:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprOctet)a).value()&((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprOctet)a).value()&((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprOctet)a).value()&((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()&((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprOctet)a).value()&((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprOctet)a).value()&((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprOctetImpl((byte)((((ExprOctet)a).value()&((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    default:  throw new TIRExceptCalculate("Can't calculate.");  
    }
  }

  public static ExprOperDef mod(ExprOperDef a, ExprOperDef b) throws RemoteException, TIRExceptCalculate {
    switch (a.get_eok_kind().value()) {
    case ExprOperKind.eok_short:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprShort)a).value()%((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprShort)a).value()%((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprShort)a).value()%((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()%((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprShort)a).value()%((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprShort)a).value()%((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprShortImpl((short)((((ExprShort)a).value()%((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_long:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongImpl((((ExprLong)a).value()%((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprLong)a).value()%((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLong)a).value()%((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongImpl(((((ExprLong)a).value()%((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprLong)a).value()%((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLong)a).value()%((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongImpl((((ExprLong)a).value()%((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_longlong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongLongImpl((((ExprLongLong)a).value()%((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongLongImpl((((ExprLongLong)a).value()%((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()%((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongLongImpl(((((ExprLongLong)a).value()%((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()%((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLongLong)a).value()%((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongLongImpl((((ExprLongLong)a).value()%((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsigshort:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigShortImpl((short)(((ExprUnsigShort)a).value()%((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprUnsigShort)a).value()%((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigShort)a).value()%((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()%((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigShort)a).value()%((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigShort)a).value()%((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()%((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()%((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()%((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigLong)a).value()%((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongImpl(((((ExprUnsigLong)a).value()%((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()%((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLong)a).value()%((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()%((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglonglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()%((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()%((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()%((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongLongImpl(((((ExprUnsigLongLong)a).value()%((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()%((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()%((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()%((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_octet:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprOctet)a).value()%((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprOctet)a).value()%((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprOctet)a).value()%((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()%((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprOctet)a).value()%((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprOctet)a).value()%((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprOctetImpl((byte)((((ExprOctet)a).value()%((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    default:  throw new TIRExceptCalculate("Can't calculate.");  
    }
  }

  public static ExprOperDef shr(ExprOperDef a, ExprOperDef b) throws RemoteException, TIRExceptCalculate {
    switch (a.get_eok_kind().value()) {
    case ExprOperKind.eok_short:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprShort)a).value()>>((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprShort)a).value()>>((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprShort)a).value()>>((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()>>((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprShort)a).value()>>((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprShort)a).value()>>((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprShortImpl((short)((((ExprShort)a).value()>>((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_long:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongImpl((((ExprLong)a).value()>>((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprLong)a).value()>>((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLong)a).value()>>((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongImpl(((((ExprLong)a).value()>>((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprLong)a).value()>>((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLong)a).value()>>((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongImpl((((ExprLong)a).value()>>((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_longlong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongLongImpl((((ExprLongLong)a).value()>>((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongLongImpl((((ExprLongLong)a).value()>>((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()>>((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongLongImpl(((((ExprLongLong)a).value()>>((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()>>((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLongLong)a).value()>>((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongLongImpl((((ExprLongLong)a).value()>>((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsigshort:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigShortImpl((short)(((ExprUnsigShort)a).value()>>((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprUnsigShort)a).value()>>((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigShort)a).value()>>((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()>>((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigShort)a).value()>>((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigShort)a).value()>>((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()>>((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()>>((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()>>((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigLong)a).value()>>((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongImpl(((((ExprUnsigLong)a).value()>>((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()>>((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLong)a).value()>>((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()>>((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglonglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()>>((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()>>((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()>>((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongLongImpl(((((ExprUnsigLongLong)a).value()>>((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()>>((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()>>((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()>>((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_octet:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprOctet)a).value()>>((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprOctet)a).value()>>((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprOctet)a).value()>>((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()>>((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprOctet)a).value()>>((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprOctet)a).value()>>((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprOctetImpl((byte)((((ExprOctet)a).value()>>((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    default:  throw new TIRExceptCalculate("Can't calculate.");  
    }
  }

  public static ExprOperDef shl(ExprOperDef a, ExprOperDef b) throws RemoteException, TIRExceptCalculate {
    switch (a.get_eok_kind().value()) {
    case ExprOperKind.eok_short:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprShort)a).value()<<((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprShort)a).value()<<((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprShort)a).value()<<((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()<<((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprShort)a).value()<<((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprShort)a).value()<<((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprShortImpl((short)((((ExprShort)a).value()<<((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_long:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongImpl((((ExprLong)a).value()<<((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprLong)a).value()<<((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLong)a).value()<<((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongImpl(((((ExprLong)a).value()<<((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprLong)a).value()<<((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLong)a).value()<<((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongImpl((((ExprLong)a).value()<<((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_longlong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprLongLongImpl((((ExprLongLong)a).value()<<((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongLongImpl((((ExprLongLong)a).value()<<((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()<<((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprLongLongImpl(((((ExprLongLong)a).value()<<((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprLongLongImpl((((ExprLongLong)a).value()<<((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprLongLong)a).value()<<((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprLongLongImpl((((ExprLongLong)a).value()<<((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsigshort:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigShortImpl((short)(((ExprUnsigShort)a).value()<<((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprUnsigShort)a).value()<<((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigShort)a).value()<<((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()<<((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigShort)a).value()<<((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigShort)a).value()<<((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigShortImpl((short)((((ExprUnsigShort)a).value()<<((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()<<((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()<<((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprUnsigLong)a).value()<<((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongImpl(((((ExprUnsigLong)a).value()<<((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()<<((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLong)a).value()<<((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongImpl((((ExprUnsigLong)a).value()<<((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_unsiglonglong:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()<<((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()<<((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()<<((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigLongLongImpl(((((ExprUnsigLongLong)a).value()<<((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()<<((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()<<((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprUnsigLongLongImpl((((ExprUnsigLongLong)a).value()<<((ExprOctet)b).value()));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    case ExprOperKind.eok_octet:
      switch (b.get_eok_kind().value()) {
      case ExprOperKind.eok_short:
        return new ExprShortImpl((short)(((ExprOctet)a).value()<<((ExprShort)b).value()));
      case ExprOperKind.eok_long:
        return new ExprLongImpl((((ExprOctet)a).value()<<((ExprLong)b).value()));
      case ExprOperKind.eok_longlong:
        return new ExprLongLongImpl((((ExprOctet)a).value()<<((ExprLongLong)b).value()));
      case ExprOperKind.eok_unsigshort:
        return new ExprUnsigShortImpl((short)((((ExprShort)a).value()<<((ExprUnsigShort)b).value())));
      case ExprOperKind.eok_unsiglong:
        return new ExprUnsigLongImpl((((ExprOctet)a).value()<<((ExprUnsigLong)b).value()));
      case ExprOperKind.eok_unsiglonglong:
        return new ExprUnsigLongLongImpl((((ExprOctet)a).value()<<((ExprUnsigLongLong)b).value()));
      case ExprOperKind.eok_octet:
        return new ExprOctetImpl((byte)((((ExprOctet)a).value()<<((ExprOctet)b).value())));
      default:  throw new TIRExceptCalculate("Can't calculate.");
      }

    default:  throw new TIRExceptCalculate("Can't calculate.");  
    }
  }

  static public ExprOperDef toNormal(ExprOperDef expr) throws RemoteException {
    if (expr == null)
      return null;
    switch (expr.get_eok_kind().value()) {
    case ExprOperKind.eok_or:
    case ExprOperKind.eok_xor:
    case ExprOperKind.eok_and:
    case ExprOperKind.eok_shr:
    case ExprOperKind.eok_shl:
    case ExprOperKind.eok_plus:
    case ExprOperKind.eok_minus:
    case ExprOperKind.eok_mul:
    case ExprOperKind.eok_div:
    case ExprOperKind.eok_mod:
      ExprOperDef o1 = toNormal(((ExprBinOperationDef) expr).operand1());
      ExprOperDef o2 = toNormal(((ExprBinOperationDef) expr).operand2());
      return new ExprBinOperationDefImpl(expr.get_eok_kind().value(), o1, o2);
    case ExprOperKind.eok_unminus:
    case ExprOperKind.eok_unplus:
    case ExprOperKind.eok_untilde:
      ExprOperDef o = toNormal(((ExprUnOperationDef) expr).operand());
      return new ExprUnOperationDefImpl(expr.get_eok_kind().value(), o);
    case ExprOperKind.eok_short:
      return new ExprShortImpl(((ExprShort) expr).value());
    case ExprOperKind.eok_long:
      return new ExprLongImpl(((ExprLong) expr).value());
    case ExprOperKind.eok_longlong:
      return new ExprLongLongImpl(((ExprLongLong) expr).value());
    case ExprOperKind.eok_unsigshort:
      return new ExprUnsigShortImpl(((ExprUnsigShort) expr).value());
    case ExprOperKind.eok_unsiglong:
      return new ExprUnsigLongImpl(((ExprUnsigLong) expr).value());
    case ExprOperKind.eok_unsiglonglong:
      return new ExprUnsigLongLongImpl(((ExprUnsigLongLong) expr).value());
    case ExprOperKind.eok_float:
      return new ExprFloatImpl(((ExprFloat) expr).value());
    case ExprOperKind.eok_double:
      return new ExprDoubleImpl(((ExprDouble) expr).value());
    case ExprOperKind.eok_longdouble:
      //return new ExprLongDoubleImpl(((ExprLongDouble) expr).value());
      return null;
    case ExprOperKind.eok_fixed:
      return new ExprFixedImpl(((ExprFixed) expr).value(), ((ExprFixed) expr).digits(), ((ExprFixed) expr).scale());
    case ExprOperKind.eok_property:
      return new ExprPropertyImpl(((ExprProperty) expr).ref_prop());
    case ExprOperKind.eok_constant:
      return new ExprConstantImpl(((ExprConstant) expr).ref_const());
    case ExprOperKind.eok_valuegen:
      ValueGenImpl ret = new ValueGenImpl(StateKind.sk_work);
      ValueGenElement[] els = ((ValueGen) expr).elements();
      for(int i=0;i<els.length;i++) {
        ret.addListItem(new ValueGenElementImpl(toNormal(els[i].expr1()), toNormal(els[i].expr2())));
      }
      return ret;
    case ExprOperKind.eok_enum:
      return new ExprEnumImpl(((ExprEnum) expr).enum(), new String(((ExprEnum) expr).value()));
    case ExprOperKind.eok_octet:
      return new ExprOctetImpl(((ExprOctet) expr).value());
    case ExprOperKind.eok_char:
      return new ExprCharImpl(((ExprChar) expr).value());
    case ExprOperKind.eok_wchar:
      return new ExprWcharImpl(((ExprWchar) expr).value());
    case ExprOperKind.eok_string:
      return new ExprStringImpl(new String(((ExprString) expr).value()));
    case ExprOperKind.eok_wstring:
      return new ExprWstringImpl(new String(((ExprWstring) expr).value()));
    case ExprOperKind.eok_default:
      return new ExprDefaultImpl(StateKind.sk_work);
    case ExprOperKind.eok_boolean:
      return new ExprBooleanImpl(((ExprBoolean) expr).value());
    }

    return null;
  }
}
