/* $Id: ProfileDef.java,v 1.2 2004/05/20 14:23:52 bures Exp $ */
package SOFA.SOFAnode.Made.TIR;
import java.rmi.RemoteException;

/** Interface for describing profile. Profile is given to the method 
    Repository::beginChanges() and it's used by clients (e.g. CDLcompiler)
    for obtaining default settings. */
public interface ProfileDef extends TIRObject {
  /** returns name of profile */
  public String name() throws RemoteException;
  /** returns all ids in profile */
  public Identification[] contents() throws RemoteException, TIRExceptLock;
  /** return id with given absolute name  or null, absolute name must begin with language name */
  public Identification lookup(String absoluteName) throws RemoteException, TIRExceptLock;
  /** add id from given contained */
  public boolean add(Identification a) throws RemoteException, TIRExceptLock, TIRExceptCreate;
  /** remove id (if is it in) from profile, absolute name must begin with language name */
  public void remove(String absoluteName) throws RemoteException, TIRExceptLock, TIRExceptCreate;
}
