/* $Id: ConnectorCacheNS.java,v 1.3 2004/05/20 14:23:52 bures Exp $ */

/*
 * Remote interface for connector cache name server
 *
 * Created on January 8, 2003, 4:31 PM
 */

package SOFA.SOFAnode.Run.CCNS;

import java.rmi.Remote;
import java.rmi.RemoteException;

/** Remote interface for registry of connector mangled names.
 *
 * @author Tomas Bures
 * @version 1.0
 */
public interface ConnectorCacheNS extends Remote {
    
    /** Returns short unique tag for long connector name. If the entry is not present in registry, it is automaticaly added and the unique tag is generated.
     * @param name Long connector name
     * @throws RemoteException
     * @return Short unique tag
     */    
    public String getHashByName(java.lang.String name) throws RemoteException;
    /** Returns long connector name for the short unique tag. If the entry is not present in registry, <code>null</code> is returned.
     * @param name Unique short tag
     * @throws RemoteException
     * @return Long connector name
     */    
    public String getNameByHash(java.lang.String hash) throws RemoteException;
    /** Returns short unique tag for long connector name. If the entry is not present in registry, <code>null</code> is returned.
     * @param name Long connector name
     * @throws RemoteException
     * @return Short unique tag
     *
     * @author Petr Hnetynka
     */    
    public String getHashByName2(java.lang.String name) throws RemoteException;
}
