package SOFA.SOFAnode.Run.DeplDockRegistry;

import java.rmi.Naming;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

public class RgRMIDockImpl extends UnicastRemoteObject implements RgRMIDock {
  String rmiport;
  String rmihost;
  
  public RgRMIDockImpl() throws RemoteException {
    rmiport = System.getProperty("sofa.rmiport","1099");
    rmihost = System.getProperty("sofa.rmihost","localhost");
  }
  
  public void rebind(String name, Remote object) throws RemoteException, java.net.MalformedURLException, java.rmi.AccessException {
    Naming.rebind("//"+rmihost+":"+rmiport+""+name, object);
//    System.out.println("Registering: //"+rmihost+":"+rmiport+""+name);
  }

  public static void main(String[] argv) throws Exception {
    if (System.getSecurityManager() == null) {
      System.setSecurityManager(new java.rmi.RMISecurityManager());
    }

    String rmiport = System.getProperty("sofa.rmiport","1099");
    String rmihost = System.getProperty("sofa.rmihost","localhost");
    System.out.print("Registering...");
    Naming.rebind("//"+rmihost+":"+rmiport+"/RgRMIDock", new RgRMIDockImpl() );
    System.out.print("OK");
  }
}
