package SOFA.SOFAnode.Run.Deployment;


/** Component deployment descriptor.
  * Generated by SOFA CodeGen.
  */

public interface DeploymentDescriptorOperations  {
          /** Tests if this component is system, i.e. top-level application component
            * @return    <tt>true</tt> if component is system
            */
  boolean isSystem() ;
          /** Return implementation version of the component.
            * @return implementation version
            */
  java.lang.String getReleaseVersion() ;
          /** Returns name of instance */
  java.lang.String getInstanceName() ;
          /** Returns runtime ID of the component instance
            * @return runtime ID
            */
  java.lang.String getInstanceId() ;
          /** Returns value of the property.
            * @param name    name of the property
            * @return    value of the property
            */
  java.lang.String getProperty(java.lang.String name) ;
          /** Returns name of the implementation class.
            * @param type    type of implementation class (e.g. builder)
            * @return   name of the class
            */
  String getImplementationClass(String type) ;
          /** Returns the deployment descriptor of the subcomponent
            * @param name    name of the subcomponent
            * @return    deployment descriptor of the subcomponent
            */
  SOFA.SOFAnode.Run.Deployment.DeploymentDescriptor getSubComponentDeploymentDescriptor(java.lang.String name) ;
          /** Returns location subcomponent. It can be tested by methods of SOFA.Util.SOFAURI.
            * @param    name   name of the subcomponent
            * @return   URI with location - see SOFA.Util.SOFAURI
            */
  java.lang.String getSubComponentLocation(java.lang.String name) ;
          /** Returns deployment descriptor of the connector.
            * @param name   name of the connected interface
            * @return    deployment descriptor of deployment descriptor
            */
  SOFA.Connector.DeploymentDescriptor getConnectorDeploymentDescriptor(java.lang.String name) ;
          /** Returns architectures absolute name without version
            * @return   architecture absolute name
            */
  String getArchitectureAbsName();
          /** Returns architectures absolute name with version
            * @return   architecture absolute name
            */
  String getArchitectureAbsNameWithVersion();
  /** Returns hashtable filled with CDL entities defined in the deployment descriptor */
  java.util.Hashtable getCDLEntities() ;
}
