/* $Id: CSProcCallBinding.java,v 1.2 2004/05/20 14:23:53 bures Exp $ */
package SOFA.SOFAnode.Util.ConnectorProtocolGen;

import SOFA.SOFAnode.Made.CDL.BadBindException;
import SOFA.SOFAnode.Made.CDL.CompBind;
import SOFA.SOFAnode.Made.CDL.CompBindOper;
import SOFA.SOFAnode.Made.CDL.DetectedConnector;
import SOFA.SOFAnode.Made.CDL.DetectedConnectors;

public class CSProcCallBinding {

  public static void addDetectedConnector(String[] connectorOperations, DetectedConnectors dc, CompBind cb) throws BadBindException {
    CompBindOper rhs, lhs;
    rhs = cb.rhs;
    lhs = cb.lhs;
    DetectedConnector cn = dc.containsConnWithSRole(rhs);
    if (cn == null) { // doesn't contain this connector
      cn = new DetectedConnector(lhs, rhs, cb.mode, cb.using);
      cn.operations = connectorOperations;
      dc.add(cn);
    } else { // this connector allready exists
      if ( (cb.using.compareTo("CSProcCall")!=0)) {
        throw new BadBindException("One interface is connected by different types of connectors.");
      }
      if (cn.bindMode != cb.mode) {
        throw new BadBindException("One interface is connected by different modes of ties.");
      }
      if ( !cn.containsSameCRole(lhs) ) {
        cn.addCRole(lhs);
      }
    }
  }
}

