/*
 * Copyright 2005
 *    Formal Methods In Software Engineering Group
 *    Institute of Computer Science
 *    Academy of Sciences of the Czech Republic
 * 
 * This code was developed by Jan Kofron <kofron@nenya.ms.mff.cuni.cz>
 * 
 */
package SOFA.SOFAnode.Util.DFSRChecker;

/**
 * This class keeps the checking results.
 */
public class CheckingResult {

    /**
     * Creates a new instance of CheckingResult.
     * @param type type of the error found
     * @param description the description of the composaition error found
     */
    public CheckingResult(int type, String description) {
        this.type = type;
        this.description = description;
    }
    
    /**
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return description;
    }
    
    /**
     * The type of the composition error
     */
    public int type;
    
    /**
     * The description of the composition error
     */
    public String description;
    
    public static final int ERR_OK = 0;
    public static final int ERR_BADACTIVITY = 1;
    public static final int ERR_NOACTIVITY = 2;
    public static final int ERR_INFINITEACTIVITY = 3;
    public static final int ERR_SYNTAXERROR = 4;
    public static final int ERR_OTHERERROR = 5;
    
}
