/*
 * $Id: DFSRPathItem.java,v 1.4 2005/07/08 12:04:11 kofron Exp $
 * 
 * Copyright 2004
 *    Distributed Systems Research Group
 *    Department of Software Engineering
 *    Faculty of Mathematics and Physics
 *    Charles University, Prague
 *
 * Copyright 2005
 *    Formal Methods In Software Engineering Group
 *    Institute of Computer Science
 *    Academy of Sciences of the Czech Republic
 * 
 * This code was developed by Jan Kofron <kofron@nenya.ms.mff.cuni.cz>
 */

package SOFA.SOFAnode.Util.DFSRChecker.DFSR;

import SOFA.SOFAnode.Util.DFSRChecker.state.State;
import SOFA.SOFAnode.Util.DFSRChecker.state.TransitionPair;

/**
 * Denotes one item of the path stack in DFSRTraverser. 
 */
public class DFSRPathItem {

    /**
     * Creates a new instance of DFSRPathItem.
     * 
     * @param stateindex the index to the transitions array
     * @param transitions all transitions from the state
     * @param state the initial state for the transitions
     */
    public DFSRPathItem(int stateindex, TransitionPair[] transitions, State state) {
        this.stateIndex = stateindex;
        this.transitions = transitions;
        this.state = state;
    }

    /**
     * Index of actual item within the transitions.
     */
    public int stateIndex;

    /**
     * The transitions from the state
     */
    public TransitionPair[] transitions;

    /**
     * The initial state
     */
    final public State state;
}