/*
 * $Id: CompositeState.java,v 1.4 2005/07/08 12:04:12 kofron Exp $
 * 
 * Copyright 2004
 *    Distributed Systems Research Group
 *    Department of Software Engineering
 *    Faculty of Mathematics and Physics
 *    Charles University, Prague
 *
 * Copyright 2005
 *    Formal Methods In Software Engineering Group
 *    Institute of Computer Science
 *    Academy of Sciences of the Czech Republic
 * 
 * This code was developed by Jan Kofron <kofron@nenya.ms.mff.cuni.cz>
 */


package SOFA.SOFAnode.Util.DFSRChecker.state;

/**
 * This class represents the composite state that consists of the references to
 * any finite number of substates. The members of this class are declared as
 * public for better performance of the SOFA.SOFAnode.Util.objectweb.fractal.behprotocols.checker.
 */
public class CompositeState extends State {

    /** Creates a new instance of CompositeState. */
    public CompositeState(State[] states) {
        this.states = states;
    }
    
    /**
     * @see SOFA.SOFAnode.Util.objectweb.fractal.behprotocols.checker.state.State#createSignature()
     */
    protected void createSignature() {
        for (int i = 0; i < states.length; ++i) {
            this.signature.concat(states[i].getSignature());
        }
    }
    
    
    /**
     * Array of pointers to child states.
     */
    final public State[] states;

}