/*
 * $Id: TransitionPair.java,v 1.4 2005/07/08 12:04:12 kofron Exp $
 * 
 * Copyright 2004
 *    Distributed Systems Research Group
 *    Department of Software Engineering
 *    Faculty of Mathematics and Physics
 *    Charles University, Prague
 *
 * Copyright 2005
 *    Formal Methods In Software Engineering Group
 *    Institute of Computer Science
 *    Academy of Sciences of the Czech Republic
 * 
 * This code was developed by Jan Kofron <kofron@nenya.ms.mff.cuni.cz>
 */


package SOFA.SOFAnode.Util.DFSRChecker.state;

import SOFA.SOFAnode.Util.DFSRChecker.node.ActionRepository;

/**
 * Represents transition form one state to another. The members of this class
 * are declared as public for better performance of the
 * SOFA.SOFAnode.Util.objectweb.fractal.behprotocols.checker.
 */
public class TransitionPair {

    /** Creates a new instance of TransitionPair */
    public TransitionPair(int eventindex, State state) {
        this.eventIndex = eventindex;
        this.state = state;
    }

    /**
     * To string function
     * 
     * @return the string representation of this transition pair
     */
    public String toString() {
        return new String(repository.getItemString(eventIndex) + "->" + state.label);
    }

    /**
     * Event index
     */
    final public int eventIndex;

    /**
     * Pointer to the state
     */
    final public State state;
    
    /**
     * pointer to the repository - for debug reasons
     */
    static public ActionRepository repository;

}