/*
 * $Id: TransitionPairs.java,v 1.1 2005/07/13 07:27:49 kofron Exp $
 * 
 * Copyright 2004
 *    Distributed Systems Research Group
 *    Department of Software Engineering
 *    Faculty of Mathematics and Physics
 *    Charles University, Prague
 *
 * Copyright 2005
 *    Formal Methods In Software Engineering Group
 *    Institute of Computer Science
 *    Academy of Sciences of the Czech Republic
 * 
 * This code was developed by Jan Kofron <kofron@nenya.ms.mff.cuni.cz>
 */

package SOFA.SOFAnode.Util.DFSRChecker.state;

import java.util.LinkedList;

/**
 * This class is top hold an array of transition pair and a single list of
 * potential bad activity dependecies across atomic actions.
 */

public class TransitionPairs {
    
    /**
     * Class for keeping the items of dependecy list
     */
    static public class IntPair {
        public IntPair() {
        }
        
        public IntPair(int first, int second) {
            this.first = first;
            this.second = second;
        }
            
        public int first;
        public int second;
    }
    
    /**
     * Constructor, dependency list is initially empty (in fact, it is null)
     * @param trans	the transitions to hold
     */
    public TransitionPairs(TransitionPair[] trans) {
        this.transitions = trans;
        this.deps = null;
    }
    
    /**
     * Constructor, dependency list is initially empty (in fact, it is null)
     * @param trans	the transitions to hold
     * @param deps	the atomic actions dependencies
     */
    public TransitionPairs(TransitionPair[] trans, LinkedList deps) {
        this.transitions = trans;
        this.deps = deps;
    }
    
    /**
     * the transitions
     */
    public TransitionPair[] transitions;
    
    /**
     * atomic actions bad activity dependencies
     */
    public LinkedList deps;

}
