/* $Id: ClassInfo.java,v 1.2 2004/05/20 14:23:53 bures Exp $ */
package SOFA.Tools.Resolver;

import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.CodeVisitor;

/** Provides information about class (read from byte code).
  * 
  * @author Petr Hnetynka
  */
public class ClassInfo {
  
  private String name;

  public ClassInfo(String fname) throws java.io.IOException {
    name = null;
    java.io.FileInputStream is = new java.io.FileInputStream(fname);
    ClassReader cr = new ClassReader(is);
    ClassVisitor cv = new ClassInfoVisitor(this);
    cr.accept(cv, false);
  }

  public String className() {
    return name;
  }

  void className(String name) {
    this.name = name;
  }

  public static void main(String [] argv) throws Exception {
    ClassInfo info = new ClassInfo(argv[0]);
    System.out.println("Class name: "+info.className());
  }
}

class ClassInfoVisitor implements ClassVisitor {
  private ClassInfo info;
  public ClassInfoVisitor(ClassInfo info) {
    this.info = info;
  }
  
  public void visit(final int access, final String name, final String superName, final String[] interfaces, final String sourceFile) {
    info.className(name);
  }
  public void visitField(final int access, final String name, final String desc, final Object value) {}
  public CodeVisitor visitMethod(final int access, final String name, final String desc, final String[] exceptions) {
    return null;
  }
  public void visitEnd() {}
  public void visitInnerClass(String name, String outerName, String innerName, int access) {}
}
