/**
 * VMProperties.java is a part of the SOFA project.
 * This file was created by pepan on 20.3.2003.
 */
package SOFA.Util;

/**
 * Contains constants of VM properties. These can be specified as an argument when
 * the Java VM is started - they must be prefixed with '-D' string.
 *
 * @author Petr Panuska
 */
public class VMProperties {
  public static final String TR_DIR = "sofa.tr.dir";
  public static final String TR_URL = "sofa.tr.url";

  /**
   * Name of TR running on this SOFAnode.
   * This property has been introduced by PP since TR and InOut were being implemented.
   */
  public static final String TR_NAME = "sofa.tr.name";

  public static final String RMI_PORT = "sofa.rmiport";
  public static final String RMI_PORT_DEF = "1099";

  public static final String RMI_HOST = "sofa.rmihost";
  public static final String RMI_HOST_DEF = "localhost";

  public static final String NODE_NAME = "sofa.nodename";
  
  public static final String NET_INFO_BASE_DIR = "sofa.net.infobasedir";
  public static final String NET_BIN_BUNDLES_DIR = "sofa.net.binbundlesdir";
  public static final String NET_SHARE_CLIENT_CACHE_DIR = "sofa.net.shareclientcachedir";
  
  public static final String NET_SHARE_ALL_COMPONENTS = "sofa.net.shareallcomponents";
  public static final String NET_SHARE_ALL_COMPONENTS_DEF = "false";
  
  public static final String NET_SEARCH_TIMEOUT = "sofa.net.searchtimeout";
  public static final String NET_SEARCH_TIMEOUT_DEF = "5000";

  public static final String NET_SHOW_DETAILED_EXCEPTIONS = "sofa.net.showdetailedexceptions";
}
